
local	Spectrum = import(".Spectrum")

local	luafft = import("...Libs.luafft")

local	Cover = {}
Cover = class("Cover", ccui.Layout)


function Cover:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self:setContentSize(cc.size(800, 800))
	
	self.m_textureName = {
		"res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/00 [Azargabra] - Zebrafish (Sleeve Front).png",
		"res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/00 [Azargabra] - Zebrafish (Sleeve Reverse).png"
	}
	
	self.m_textureMode = 1
	
	self:setBackGroundImage(self.m_textureName[self.m_textureMode])
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseDown = self.onMouseDown
		
		self:addEventListener(
			eventMouse
		)
	end
	
	do
		local	spectrum = Spectrum:create()
		spectrum:setContentSize(self:getContentSize())
		self:addChild(spectrum)
	end
	
end


function Cover:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		self.m_textureMode = self.m_textureMode + 1
		if self.m_textureMode > #self.m_textureName then
			self.m_textureMode = 1
		end
		self:setBackGroundImage(self.m_textureName[self.m_textureMode])
	end
end


return Cover

