local	Text_Url = import(".Text_Url")

local	MiniBrowser_Resize = import(".MiniBrowser_Resize")


local	MiniBrowser_MainBottom = {}
MiniBrowser_MainBottom = class("MiniBrowser_MainBottom", ccui.Layout)

function MiniBrowser_MainBottom:ctor(...)
	ccui.Layout.ctor(self, ...)
	
--	self:setContentSize(cc.size(275, 38))
end

function MiniBrowser_MainBottom:onEnter()
	
	
	-- [
	do
		local	image = cc.Sprite:create()
		local	rect = cc.rect(0, 42, 125, 38)
		image:initWithFile("res/skins/pxtone/MB.bmp", rect)
		image:setName("left")
		image:setLocalZOrder(1)
		image.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				0 + self:getContentSize().width  * 0.5,
				0 + self:getContentSize().height * 0.5
			)
		end
		self:addChild(image)
	end
	
	-- E[
	do
		local	image = cc.Sprite:create()
		local	rect = cc.rect(0, 81, 125, 38)
		image:initWithFile("res/skins/pxtone/MB.bmp", rect)
		image:setName("right")
		image:setLocalZOrder(1)
		image.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				parent:getContentSize().width - self:getContentSize().width + self:getContentSize().width  * 0.5,
				0 + self:getContentSize().height * 0.5
			)
		end
		self:addChild(image)
	end
	
	-- TCY
	do
		local	resize = MiniBrowser_Resize:create()
		local	position = cc.rect(256, 19, 19, 19)
		resize:setName("resize")
		resize:setLocalZOrder(1)
		resize.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				parent:getContentSize().width - 19,
				parent:getContentSize().height - 19
			)
		end
		self:addChild(resize)
	end
	
	-- 208 220
	-- 299, 233
	-- 92 14
	--    13
	
	-- pẌ
	do
		local	url = Text_Url:create()
		url:setName("url")
		url:setLocalZOrder(2)
		self:addChild(url)
	end
	
	-- e{^
	local	buttons = {
			-- ^Cgo[֘A
			-- O
			{
				name = "buttonPrev",
				size = cc.size(15, 18),
				position = cc.rect(9 + 15 * 0, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(158 + 15 * 0, 42, 15, 18),
				onClick = handler(self, self.buttonPrev)
			},
			-- 
			{
				name = "buttonNext",
				size = cc.size(15, 18),
				position = cc.rect(9 + 15 * 1, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(158 + 15 * 1, 42, 15, 18),
				onClick = handler(self, self.buttonNext)
			},
			-- ꎞ~
			{
				name = "buttonStop",
				size = cc.size(15, 18),
				position = cc.rect(9 + 15 * 2, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(158 + 15 * 2, 42, 15, 18),
				onClick = handler(self, self.buttonStop)
			},
			-- [h
			{
				name = "buttonReload",
				size = cc.size(15, 18),
				position = cc.rect(9 + 15 * 3, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(158 + 15 * 3, 42, 15, 18),
				onClick = handler(self, self.buttonReload)
			},
			-- I[v
			{
				name = "buttonOpen",
				size = cc.size(15, 18),
				position = cc.rect(9 + 15 * 4, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(158 + 15 * 4, 42, 15, 18),
				onClick = handler(self, self.buttonOpen)
			},
	}
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		button:setLocalZOrder(1)
		if bs.name then
			button:setName(bs.name)
		end
		
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onUp = handler(self, self.buttonOnForeground),
				onDown = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	self:cleanup()
	self:onResize()
end


function MiniBrowser_MainBottom:buttonOnForeground()
	self:getParent():setLocalZOrderForeground()
end


function MiniBrowser_MainBottom:buttonPrev(
	button
	)
	local	parent = self:getParent()
	if parent then
		parent:setFontSize(parent:getFontSize() - 1)
	end
end


function MiniBrowser_MainBottom:buttonNext(
	button
	)
	local	parent = self:getParent()
	if parent then
		parent:setFontSize(parent:getFontSize() + 1)
	end
end


function MiniBrowser_MainBottom:buttonStop(
	button
	)
	
end


function MiniBrowser_MainBottom:buttonReload(
	button
	)
	
end


function MiniBrowser_MainBottom:buttonOpen(
	button
	)
	
	if string.len(self:getParent():getUrl()) > 1 then
		love.system.openURL(self:getParent():getUrl())
	end
end



function MiniBrowser_MainBottom:onResize(size)
	size = size or self:getParent():getContentSize()
	
	-- RecTCYύX
	self:setContentSize(cc.size(size.width, 38))
	self:setPosition(cc.p(0, size.height - self:getContentSize().height))
	
	local	children = self:getChildren()
	for key, child in ipairs(children) do
		if child:getName() == nil then
			child:removeFromParent()
		elseif type(child.onResize) == "function" then
			child:onResize()
		end
	end
	
	-- n
	for left = 125, self:getContentSize().width - 125 - 1, 25 do
		local	image = cc.Sprite:create()
		local	rect = cc.rect(127,  81, 25, 38)
		image:initWithFile("res/skins/pxtone/MB.bmp", rect)
		image:setPosition(
			left + image:getContentSize().width  * 0.5,
			0    + image:getContentSize().height * 0.5
		)
		self:addChild(image)
	end
end

return MiniBrowser_MainBottom
