

local	MiniBrowser_ScrollView = import(".MiniBrowser_ScrollView")


local	MiniBrowser_MainMiddle = {}
MiniBrowser_MainMiddle = class("MiniBrowser_MainMiddle", ccui.Layout)

function MiniBrowser_MainMiddle:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	-- 
	do
		local	layout = MiniBrowser_ScrollView:create()
		layout:setClippingType(1)
		layout:setName("scrollView")
		layout:setLocalZOrder(1)
		layout.onResize = function(self, parent)
			parent = parent or self:getParent()
			
			self:setContentSize(cc.size(parent:getContentSize().width - 19, parent:getContentSize().height))
			self:setPosition(11, 0)
		end
		self:addChild(layout)
	end
end


function MiniBrowser_MainMiddle:onEnter()
	
	
	self:cleanup()
	self:onResize()
end


function MiniBrowser_MainMiddle:onResize(size)
	size = size or self:getParent():getContentSize()
	
	-- RecTCYύX
	self:setContentSize(cc.size(size.width, size.height - 58))
	self:setPosition(cc.p(0, 20))
	
	local	children = self:getChildren()
	for key, child in ipairs(children) do
		if child:getName() == nil then
			child:removeFromParent()
		elseif type(child.onResize) == "function" then
			child:onResize()
		end
	end
	
	-- [
	for top = 0, self:getContentSize().height - 1, 29 do
		do
			local	image = cc.Sprite:create()
			local	rect = cc.rect(127, 42, 11, 29)
			image:initWithFile("res/skins/pxtone/MB.bmp", rect)
			image:setPosition(
				0   + image:getContentSize().width  * 0.5,
				top + image:getContentSize().height * 0.5
			)
			self:addChild(image)
		end
		do
			local	image = cc.Sprite:create()
			local	rect = cc.rect(139, 42, 8, 29)
			image:initWithFile("res/skins/pxtone/MB.bmp", rect)
			image:setPosition(
				self:getContentSize().width - image:getContentSize().width  * 0.5,
				top + image:getContentSize().height * 0.5
			)
			self:addChild(image)
		end
	end
end

return MiniBrowser_MainMiddle
