local	MiniBrowser_MainTop = {}


MiniBrowser_MainTop = class("Minibrowser_MainTop", ccui.Layout)


function MiniBrowser_MainTop:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self:scheduleUpdate()
end


function MiniBrowser_MainTop:onEnter()
	
	self:setContentSize(cc.size(self:getParent():getContentSize().width, 20))
	
	-- [
	do
		local	image = cc.Sprite:create()
		image.m_rects = {}
		table.insert(image.m_rects, cc.rect(0,  0, 25, 20))
		table.insert(image.m_rects, cc.rect(0, 21, 25, 20))
		image:initWithFile("res/skins/pxtone/MB.bmp", image.m_rects[1])
		image:setName("left")
		image:setLocalZOrder(1)
		image.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				0 + self:getContentSize().width  * 0.5,
				0 + self:getContentSize().height * 0.5
			)
		end
		self:addChild(image)
	end
	
	-- 
	do
		local	image = cc.Sprite:create()
		image.m_rects = {}
		table.insert(image.m_rects, cc.rect(26,  0, 100, 20))
		table.insert(image.m_rects, cc.rect(26, 21, 100, 20))
		image:initWithFile("res/skins/pxtone/MB.bmp", image.m_rects[1])
		image:setName("center")
		image:setLocalZOrder(1)
		image.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				parent:getContentSize().width * 0.5,
				0 + self:getContentSize().height * 0.5
			)
		end
		self:addChild(image)
	end
	
	-- E[
	do
		local	image = cc.Sprite:create()
		image.m_rects = {}
		table.insert(image.m_rects, cc.rect(153,  0, 25, 20))
		table.insert(image.m_rects, cc.rect(153, 21, 25, 20))
		image:initWithFile("res/skins/pxtone/MB.bmp", image.m_rects[1])
		image:setName("right")
		image:setLocalZOrder(1)
		image.onResize = function(self, parent)
			parent = parent or self:getParent()
			self:setPosition(
				parent:getContentSize().width - self:getContentSize().width + self:getContentSize().width  * 0.5,
				0 + self:getContentSize().height * 0.5
			)
		end
		self:addChild(image)
	end
	
	
	local	buttons = {
			-- O
			{
				name = "buttonClose",
				size = cc.size(9, 9),
--				position = cc.rect(9 + 15 * 0, 9, 15, 18),
				selected = "res/skins/pxtone/MB.bmp",
				selectedRect = cc.rect(148, 42, 9, 9),
				onResize = function(self, parent)
					parent = parent or self:getParent()
					self:setPosition(
						parent:getContentSize().width - self:getContentSize().width * 0.5 - 2,
						3 + self:getContentSize().height * 0.5
					)
				end,
				onClick = handler(self, self.buttonClose)
			},
	}
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		button:setLocalZOrder(1)
		if bs.name then
			button:setName(bs.name)
		end
		
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		if bs.onResize then
			button.onResize = bs.onResize
		end
		
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onUp = handler(self, self.buttonOnForeground),
				onDown = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	self:cleanup()
	self:onResize()
end


function MiniBrowser_MainTop:buttonOnForeground()
	self:getParent():setLocalZOrderForeground()
end


function MiniBrowser_MainTop:buttonClose(
	button
	)
	
	self:getParent():setVisible(false)
end



function MiniBrowser_MainTop:update(dt)
	local	children = self:getChildren()
	local	pos
	if self:getParent():isForeground() then pos = 1 else pos = 2 end
	for i, child in ipairs(children) do
		if child.m_rects then
			child:setTextureRect(child.m_rects[pos])
		end
	end
end


function MiniBrowser_MainTop:onResize(size)
	size = size or self:getParent():getContentSize()
	
	-- RecTCYύX
	self:setContentSize(cc.size(size.width, 20))
	
	local	children = self:getChildren()
	for key, child in ipairs(children) do
		if child:getName() == nil then
			child:removeFromParent()
		elseif type(child.onResize) == "function" then
			child:onResize()
		end
	end
	
	-- n
	for left = 25, self:getContentSize().width - 25 - 1, 25 do
		local	image = cc.Sprite:create()
		image.m_rects = {}
		table.insert(image.m_rects, cc.rect(127,  0, 25, 20))
		table.insert(image.m_rects, cc.rect(127, 21, 25, 20))
		image:initWithFile("res/skins/pxtone/MB.bmp", image.m_rects[1])
		image:setPosition(
			left + image:getContentSize().width  * 0.5,
			0    + image:getContentSize().height * 0.5
		)
		self:addChild(image)
	end
end

return MiniBrowser_MainTop
