
local	MiniBrowser_Resize = {}

MiniBrowser_Resize = class("MiniBrowser_Resize", cc.Node)

function MiniBrowser_Resize:ctor(...)
	cc.Node.ctor(self, ...)
	self:setContentSize(cc.size(19, 19))
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
end

function MiniBrowser_Resize:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	cellSize = self:getParent():getParent().m_cellSize
		local	cellMin = self:getParent():getParent().m_cellMin
		local	cell = self:getParent():getParent().m_cell
		local	location = self:getParent():getParent():convertToNodeSpace(event:getLocation())
		
		local	cell_x = math.floor((location.x - 275 + self:getContentSize().width) / cellSize.width)
		local	cell_y = math.floor((location.y - 116 + self:getContentSize().height) / cellSize.height)
		
		if cell_x < 0 then cell_x = 0 end
		if cell_y < 0 then cell_y = 0 end
		
		cell_x = cell_x + cellMin.x
		cell_y = cell_y + cellMin.y
		
		if cell_x ~= cell.x or cell_y ~= cell.y then
			self:getParent():getParent():setCell(cc.p(cell_x, cell_y))
		end
	end
end

function MiniBrowser_Resize:onMouseDown(
	event
	)
	
	if self:isHover(event:getLocation()) then
		
		-- J[\Zbg
		if love.mouse.hasCursor() then
			love.mouse.setCursor(love.mouse.getSystemCursor("sizenwse"))
		end
		
		self:getParent():getParent():setForeground()
		event:setCapture(self)
		return true
	end
end

function MiniBrowser_Resize:onMouseUp(
	event
	)
	if event:isCapture(self) then
		
		-- J[\
		if love.mouse.hasCursor() then
			love.mouse.setCursor()
		end
		
		event:removeCapture()
		return true
	end
end

return MiniBrowser_Resize

