local	MiniBrowser_ScrollView = {}
MiniBrowser_ScrollView = class("MiniBrowser_ScrollView", ccui.ScrollView)

function MiniBrowser_ScrollView:ctor(...)
	ccui.ScrollView.ctor(self, ...)
	
	do
		local	eventMouse = cc.EventMouse:create()
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		eventMouse.onScroll = self.onScroll
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end


function MiniBrowser_ScrollView:onMouseMove(
	event
	)
	if event:isCapture(self) then
		self.m_endLocation = event:getLocation()
	end
end


function MiniBrowser_ScrollView:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		
		-- J[\Zbg
		if love.mouse.hasCursor() then
			love.mouse.setCursor(love.mouse.getSystemCursor("sizeall"))
		end
		
		self.m_startLocation = event:getLocation()
		self.m_endLocation = event:getLocation()
		
		self:getParent():getParent():setLocalZOrderForeground()
		event:setCapture(self)
		return true
	end
end


function MiniBrowser_ScrollView:onMouseUp(
	event
	)
	if event:isCapture(self) then
		self.m_endLocation = nil
		self.m_startLocation = nil
		-- J[\
		if love.mouse.hasCursor() then
			love.mouse.setCursor()
		end
		event:removeCapture()
		return true
	end
end


function MiniBrowser_ScrollView:onScroll(
	event
	)
	
	if self:isHover(event:getLocation()) and event:isCapture(self) == false then
		
		local	percent = self:getPositionPercent()
		
		percent.x = percent.x + event:getScroll().x * (-0.1)
		percent.y = percent.y + event:getScroll().y * (-0.1)
		
		self:jumpToPercentBothDirection(percent)
		
		return true
	end
end


function MiniBrowser_ScrollView:update(dt)
	
	if self.m_startLocation then
		local	lookAtPos
		lookAtPos = self:getInnerContainer():convertToNodeSpace(self.m_endLocation)
		lookAtPos = cc.pSub(lookAtPos, cc.pSub(self:convertToNodeSpace(self.m_endLocation), cc.pMul(cc.pFromSize(self:getContentSize()), 0.5)))
		lookAtPos = cc.pSub(lookAtPos, cc.pMul(cc.pSub(self.m_startLocation, self.m_endLocation), dt * 30))
		self:lookAt(lookAtPos.x, lookAtPos.y)
		
		
--		lookAtPos = self:getInnerContainer():convertToNodeSpace(self.m_endLocation)
--		lookAtPos = cc.pSub(lookAtPos, cc.pSub(self:convertToNodeSpace(self.m_endLocation), cc.pMul(cc.pFromSize(self:getContentSize()), 0.5)))
	end
end


return MiniBrowser_ScrollView


