
local	Slave = import("..Components.Slave")

local	Titlebar = import(".Titlebar")

local	Posbar = import(".Posbar")
local	Monoster_Mono = import(".Monoster_Mono")
local	Monoster_Ster = import(".Monoster_Ster")
local	Volume = import(".Volume")
local	Numbers_Minus = import(".Numbers_Minus")
local	Numbers_MinuteTop = import(".Numbers_MinuteTop")
local	Numbers_MinuteDown = import(".Numbers_MinuteDown")
local	Numbers_SecondTop = import(".Numbers_SecondTop")
local	Numbers_SecondDown = import(".Numbers_SecondDown")
local	Numbers_TimeReverse = import(".Numbers_TimeReverse")

local	Text_Bit = import(".Text_Bit")
local	Text_Rate = import(".Text_Rate")
local	Text_Name = import(".Text_Name")

local	Playpaus_Dot = import(".Playpaus_Dot")
local	Playpaus_Icon = import(".Playpaus_Icon")

local	Player = {}
Player = class("Player", Slave)

function Player:ctor(...)
	Slave.ctor(self, ...)
	
	-- TCYŒ艻
	self:setContentSize(cc.size(275, 116))
	
	-- Cwi
	do
		local	sprite = cc.Sprite:create("res/skins/pxtone/MAIN.bmp")
		sprite:setPosition(
			sprite:getContentSize().width * 0.5,
			sprite:getContentSize().height * 0.5
		)
		self:addChild(sprite)
	end
	
	-- ^Cgo[
	do
		local	titlebar = Titlebar:create()
		titlebar:setPosition(0, 0)
		self:addChild(titlebar)
	end
	
	-- e{^
	local	buttons = {
			-- ^Cgo[֘A
			-- }[N
			{
				size = cc.size(9, 9),
				position = cc.rect(6, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarMark)
			},
			-- ŏ
			{
				size = cc.size(9, 9),
				position = cc.rect(244, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 + 9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 + 9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarMinisize)
			},
			-- e
			{
				size = cc.size(9, 9),
				position = cc.rect(254, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 * 0, 18 + 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 * 1, 18 + 9 * 0, 9, 9),
				onClick = handler(self, self.buttonTitlebarShade)
			},
			-- 
			{
				size = cc.size(9, 9),
				position = cc.rect(264, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(18 + 9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(18 + 9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarClose)
			},
			
			-- Đ֘A
			-- ߂
			{
				size = cc.size(23, 18),
				position = cc.rect(16, 88, 23, 18),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 0, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 0, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPrev)
			},
			-- Đ
			{
				size = cc.size(23, 18),
				position = cc.rect(16 + 23 * 1, 88, 23, 18),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 1, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 1, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPlay)
			},
			-- ꎞ~
			{
				size = cc.size(23, 18),
				position = cc.rect(16 + 23 * 2, 88, 23, 18),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 2, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 2, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPause)
			},
			-- ~
			{
				size = cc.size(23, 18),
				position = cc.rect(16 + 23 * 3, 88, 23, 18),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 3, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 3, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackStop)
			},
			-- 
			{
				size = cc.size(22, 18),
				position = cc.rect(16 + 23 * 4, 88, 22, 18),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 4, 0, 22, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 4, 18, 22, 18),
				onClick = handler(self, self.buttonPlaybackNext)
			},
			-- t@CJ
			{
				size = cc.size(22, 16),
				position = cc.rect(136, 89, 22, 16),
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(114, 0, 22, 16),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(114, 16, 22, 16),
				onClick = handler(self, self.buttonOpenFile)
			},
			-- PLAYEDIT̃I
			{
				name = "pleditOn",
				size = cc.size(23, 12),
				position = cc.rect(242, 58, 23, 12),
				normal = "res/skins/pxtone/SHUFREP.bmp",
				normalRect = cc.rect(23, 61, 23, 12),
				selected = "res/skins/pxtone/SHUFREP.bmp",
				selectedRect = cc.rect(23 + 46, 61, 23, 12),
				onClick = handler(self, self.buttonPleditOn)
			},
			-- PLAYEDIT̃It
			{
				name = "pleditOff",
				size = cc.size(23, 12),
				position = cc.rect(242, 58, 23, 12),
				normal = "res/skins/pxtone/SHUFREP.bmp",
				normalRect = cc.rect(23, 61 + 12, 23, 12),
				selected = "res/skins/pxtone/SHUFREP.bmp",
				selectedRect = cc.rect(23 + 46, 61 + 12, 23, 12),
				onClick = handler(self, self.buttonPleditOff)
			},
			-- REPEAT̃I
			{
				name = "repeatOn",
				size = cc.size(28, 15),
				position = cc.rect(210, 89, 28, 15),
				normal = "res/skins/pxtone/SHUFREP.bmp",
				normalRect = cc.rect(0, 0, 28, 15),
				selected = "res/skins/pxtone/SHUFREP.bmp",
				selectedRect = cc.rect(0, 15, 28, 15),
				onClick = handler(self, self.buttonRepeatOn)
			},
			-- REPEAT̃It
			{
				name = "repeatOff",
				size = cc.size(28, 15),
				position = cc.rect(210, 89, 28, 15),
				normal = "res/skins/pxtone/SHUFREP.bmp",
				normalRect = cc.rect(0, 30, 28, 15),
				selected = "res/skins/pxtone/SHUFREP.bmp",
				selectedRect = cc.rect(0, 45, 28, 15),
				onClick = handler(self, self.buttonRepeatOff)
			}
	}
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		if bs.name then
			button:setName(bs.name)
		end
		
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onUp = handler(self, self.buttonOnForeground),
				onDown = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	
	-- |WVo[
	do
		local	posbar = Posbar:create()
		posbar:setPosition(16, 72)
		self:addChild(posbar)
	end
	
	-- bit\
	do
		local	bit = Text_Bit:create()
		local	position = cc.rect(111, 43, bit:getContentSize().width, bit:getContentSize().height)
		bit:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(bit)
	end
	
	-- rate\
	do
		local	rate = Text_Rate:create()
		local	position = cc.rect(156, 43, rate:getContentSize().width, rate:getContentSize().height)
		rate:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(rate)
	end
	
	-- ̕\
	do
		local	name = Text_Name:create()
		local	position = cc.rect(114, 24, name:getContentSize().width, name:getContentSize().height)
		name:setPosition(114, 24)
		self:addChild(name)
	end
	
	-- Đ
	do
		local	icon = Playpaus_Icon:create()
		local	position = cc.rect(26, 28, icon:getContentSize().width, icon:getContentSize().height)
		icon:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(icon)
	end
	do
		local	dot = Playpaus_Dot:create()
		local	position = cc.rect(24, 28, dot:getContentSize().width, dot:getContentSize().height)
		dot:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(dot)
	end
	
	
	-- m
	do
		local	mono = Monoster_Mono:create()
		local	position = cc.rect(211, 41, 27, 12)
		mono:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(mono)
	end
	-- XeI
	do
		local	ster = Monoster_Ster:create()
		local	position = cc.rect(239, 41, 29, 12)
		ster:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(ster)
	end
	-- {[
	do
		local	volume = Volume:create()
		volume:setPosition(107, 57)
		self:addChild(volume)
	end
	
	-- io[Y
	do
		local	minus = Numbers_Minus:create()
		local	position = cc.rect(36, 26, 9, 13)
		minus:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(minus)
	end
	do
		local	minuteTop = Numbers_MinuteTop:create()
		local	position = cc.rect(48, 26, 9, 13)
		minuteTop:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(minuteTop)
	end
	do
		local	minuteDown = Numbers_MinuteDown:create()
		local	position = cc.rect(60, 26, 9, 13)
		minuteDown:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(minuteDown)
	end
	do
		local	secondTop = Numbers_SecondTop:create()
		local	position = cc.rect(78, 26, 9, 13)
		secondTop:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(secondTop)
	end
	do
		local	secondDown = Numbers_SecondDown:create()
		local	position = cc.rect(90, 26, 9, 13)
		secondDown:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(secondDown)
	end
	do
		local	timeReverse = Numbers_TimeReverse:create()
		local	position = cc.rect(36, 26, 63, 13)
		timeReverse:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(timeReverse)
	end
	
	do
		local	eventMouse = cc.EventMouse:create()
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end


function Player:update(dt)
	
	Slave.update(self, dt)
	
	local	pledit = self:getParent():getParent():getChildByName("pledit")
	local	pleditOn = self:getChildByName("pleditOn")
	local	pleditOff = self:getChildByName("pleditOff")
	
	if pledit and pleditOn and pleditOff then
		if pledit:isVisible() then
			pleditOn:setVisible(false)
			pleditOff:setVisible(true)
		else
			pleditOn:setVisible(true)
			pleditOff:setVisible(false)
		end
	end
	
	local	audioList = self:getScene():getAudioList()
	local	repeatOn = self:getChildByName("repeatOn")
	local	repeatOff = self:getChildByName("repeatOff")
	if audioList and repeatOn and repeatOff then
		if audioList:isLooping() then
			repeatOn:setVisible(false)
			repeatOff:setVisible(true)
		else
			repeatOn:setVisible(true)
			repeatOff:setVisible(false)
		end
	end
end


function Player:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	object = self:getMaster()
		if object == nil then object = self end
		local	position = cc.pAdd(object:getPosition(), event:getDelta())
		object:setPosition(position)
	end
end


function Player:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		self:setForeground()
		event:setCapture(self)
		return true
	end
end


function Player:onMouseUp(
	event
	)
	if event:isCapture(self) then
		event:removeCapture()
		return true
	end
end


function Player:buttonOnForeground(
	button,
	event
	)
	
	-- őOʂ
	self:setForeground()
	
end

function Player:buttonTitlebarMark(
	-- }[NNbN
	button
	)
	
--	love.system.openURL("http://studiopixel.jp/pxtone/")
end


function Player:buttonTitlebarMinisize(
	-- ŏ
	button
	)
	self:getParent():setVisible(false)
end


function Player:buttonTitlebarShade(
	-- e
	button
	)
	local	master = self:getMaster()
	if master then
		master:setShade(true)
	end
end


function Player:buttonTitlebarClose(
	-- 
	button
	)
	self:getParent():setVisible(false)
end


function Player:buttonPlaybackPrev(
	-- ߂鏈
	button
	)
	self:getScene():getAudioList():prev()
end


function Player:buttonPlaybackPlay(
	-- Đ
	button
	)
	self:getScene():getAudioList():play()
end


function Player:buttonPlaybackPause(
	-- ꎞ~
	button
	)
	self:getScene():getAudioList():pause()
end


function Player:buttonPlaybackStop(
	-- ~
	button
	)
	self:getScene():getAudioList():stop()
end


function Player:buttonPlaybackNext(
	-- ւ̏
	button
	)
	self:getScene():getAudioList():next()
end


function Player:buttonOpenFile(
	button
	)
	love.system.openURL("http://studiopixel.jp/pxtone/")
end


function Player:buttonPleditOn(
	button
	)
	
	local	pledit = self:getParent():getParent():getChildByName("pledit")
	if pledit then
		pledit:setVisible(true)
		pledit:setLocalZOrderForeground()
	end
end

function Player:buttonPleditOff(
	button
	)
	
	local	pledit = self:getParent():getParent():getChildByName("pledit")
	if pledit then
		pledit:setVisible(false)
	end
end

function Player:buttonRepeatOn(
	button
	)
	local	audioList = self:getScene():getAudioList()
	if audioList then
		audioList:setLooping(true)
	end
end

function Player:buttonRepeatOff(
	button
	)
	local	audioList = self:getScene():getAudioList()
	if audioList then
		audioList:setLooping(false)
	end
end

return Player
