local	Playpaus_Icon = {}

Playpaus_Icon = class("Playpaus_Icon", cc.Sprite)

function Playpaus_Icon:ctor(...)
	cc.Sprite.ctor(self, ...)
	self:setContentSize(cc.p(9, 9))
	
	self.m_textureRects = {
		cc.rect(18, 0, 9, 9),	-- stop
		cc.rect( 0, 0, 9, 9),	-- play
		cc.rect( 9, 0, 9, 9),	-- pause
	}
	
	self:initWithFile("res/skins/pxtone/PLAYPAUS.bmp", self.m_textureRects[1])
	
	self:scheduleUpdate()
end

function Playpaus_Icon:update(dt)
	local	audioManager = self:getScene():getAudioManager()
	local	source = nil
	if audioManager then source = audioManager:getSource() end
	if source and source:isPlaying() then
		self:setTextureRect(self.m_textureRects[2])
	elseif source and source:isPaused() then
		self:setTextureRect(self.m_textureRects[3])
	else
		self:setTextureRect(self.m_textureRects[1])
	end
end


return Playpaus_Icon
