local	Volume = {}
Volume = class("Volume", cc.Layer)

function Volume:ctor(...)
	cc.Layer.ctor(self, ...)
	
	-- TCYŒ
	self:setContentSize(cc.size(68, 13))
	
	self.m_baseTextureRects = {}
	
	-- ỹXCheLX`Zbg
	for i = 1, 28 do
		table.insert(
			self.m_baseTextureRects,
			cc.rect(0, 15 * (i - 1), 68, 13)
		)
	end
	
	do
		-- y
		local	base = cc.Sprite:create()
		base:initWithFile("res/skins/pxtone/VOLUME.bmp", self.m_baseTextureRects[#self.m_baseTextureRects])
		base:setPosition(self:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		base:setName("base")
		self:addChild(base)
	end
	
	self.m_slideBallTextureRects = {}
	self.m_slideBallTextureRects = {
		cc.rect(15, 422, 14, 8),	-- normal
		cc.rect( 0, 422, 14, 8),	-- active
	}
	
	do
		-- XCh{[
		local	slidBall = cc.Sprite:create()
		slidBall:initWithFile("res/skins/pxtone/VOLUME.bmp", self.m_slideBallTextureRects[1])
		slidBall:setPosition(self:getContentSize().width - slidBall:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		slidBall:setName("slidBall")
		self:addChild(slidBall)
	end
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end

function Volume:onMouseMove(
	event
	)
	local	slidBall = self:getChildByName("slidBall")
	if event:isCapture(self) and slidBall then
		local	slidBallWidth = slidBall:getContentSize().width
		local	boundingBox = self:getBoundingBox()
		local	posx = event:getLocation().x - boundingBox.x - slidBallWidth * 0.5
		local	volume = posx / (boundingBox.width - slidBallWidth)
		if volume < 0 then volume = 0 end
		if volume > 1 then volume = 1 end
		love.audio.setVolume(volume)
		self:updateVolume()
	end
end


function Volume:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		
		-- eőOʂ
		self:getParent():setForeground()
--		self:getParent():setLocalZOrderForeground()
		
		self:getScene():getAudioList():setSeekVolume(true)
		event:setCapture(self)
		return true
	end
end


function Volume:onMouseUp(
	event
	)
	if event:isCapture(self) then
		event:removeCapture()
		self:getScene():getAudioList():setSeekVolume(false)
		return true
	end
end


function Volume:updateVolume(
	-- {[XV
	volume
	)
	volume = volume or love.audio.getVolume()
	local	index = math.floor(volume * 27) + 1
	
	local	base = self:getChildByName("base")
	if base then
		base:setTextureRect(self.m_baseTextureRects[index])
	end
	local	slidBall = self:getChildByName("slidBall")
	if slidBall then
		slidBall:setPosition(slidBall:getContentSize().width * 0.5 + index * 2 - 1, self:getContentSize().height * 0.5)
	end
end


function Volume:update(
	dt
	)
	self:updateVolume()
end


return Volume

