local	Slave = import("..Components.Slave")
local	Posbar = import(".Posbar")
local	Numbers_Minus = import(".Numbers_Minus")
local	Numbers_Minute = import(".Numbers_Minute")
local	Numbers_Second = import(".Numbers_Second")
local	Numbers_TimeReverse = import(".Numbers_TimeReverse")


local	PlayerShade = {}

PlayerShade = class("PlayerShade", Slave)

function PlayerShade:ctor(...)
	Slave.ctor(self, ...)
	
	self:setContentSize(cc.size(275, 14))
	
	do
		local	background = cc.Sprite:create("res/skins/pxtone/TITLEBAR.bmp", cc.rect(27, 29, 275, 14))
		background:setPosition(self:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		background:setName("background")
		self:addChild(background)
	end
	
	-- e{^
	local	buttons = {
			-- ^Cgo[֘A
			-- }[N
			{
				size = cc.size(9, 9),
				position = cc.rect(6, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarMark)
			},
			-- ŏ
			{
				size = cc.size(9, 9),
				position = cc.rect(244, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 + 9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 + 9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarMinisize)
			},
			-- e
			{
				size = cc.size(9, 9),
				position = cc.rect(254, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(9 * 0, 18 + 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(9 * 1, 18 + 9 * 0, 9, 9),
				onClick = handler(self, self.buttonTitlebarShade)
			},
			-- 
			{
				size = cc.size(9, 9),
				position = cc.rect(264, 3, 9, 9),
				normal = "res/skins/pxtone/TITLEBAR.bmp",
				normalRect = cc.rect(18 + 9 * 0, 9 * 0, 9, 9),
				selected = "res/skins/pxtone/TITLEBAR.bmp",
				selectedRect = cc.rect(18 + 9 * 0, 9 * 1, 9, 9),
				onClick = handler(self, self.buttonTitlebarClose)
			},
			-- O
			{
				size = cc.size(8, 10),
				position = cc.rect(168, 2, 8, 10),
				onClick = handler(self, self.buttonPlaybackPrev)
			},
			-- Đ
			{
				size = cc.size(10, 10),
				position = cc.rect(176, 2, 10, 10),
				onClick = handler(self, self.buttonPlaybackPlay)
			},
			-- |[Y
			{
				size = cc.size(9, 10),
				position = cc.rect(186, 2, 9, 10),
				onClick = handler(self, self.buttonPlaybackPause)
			},
			-- ~
			{
				size = cc.size(9, 10),
				position = cc.rect(195, 2, 9, 10),
				onClick = handler(self, self.buttonPlaybackStop)
			},
			-- 
			{
				size = cc.size(11, 10),
				position = cc.rect(204, 2, 11, 10),
				onClick = handler(self, self.buttonPlaybackNext)
			},
			-- I[v
			{
				size = cc.size(10, 10),
				position = cc.rect(215, 2, 10, 10),
				onClick = handler(self, self.buttonOpenFile)
			},
	}
	
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onDown = handler(self, self.buttonOnForeground),
				onUp = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	-- io[Y
	do
		local	minus = Numbers_Minus:create()
		local	position = cc.rect(129, 4, 5, 6)
		minus:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(minus)
	end
	
	-- 
	do
		local	numbers_minute = Numbers_Minute:create()
		local	rect = cc.rect(134, 4, 10, 6)
		numbers_minute:setPosition(cc.rectGetMidX(rect), cc.rectGetMidY(rect))
		self:addNumber(numbers_minute)
	end
	
	-- b
	do
		local	numbers_second = Numbers_Second:create()
		local	rect = cc.rect(147, 4, 10, 6)
		numbers_second:setPosition(cc.rectGetMidX(rect), cc.rectGetMidY(rect))
		self:addNumber(numbers_second)
	end
	
	-- ]
	do
		local	timeReverse = Numbers_TimeReverse:create()
		local	position = cc.rect(126, 5, 32, 6)
		timeReverse:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(timeReverse)
	end
	
	-- ʒu
	do
		local	posbar = Posbar:create()
		posbar:setPosition(cc.p(226, 4))
		self:addChild(posbar)
	end
	
	do
		local	eventMouse = cc.EventMouse:create()
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end

function PlayerShade:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	object = self:getMaster()
		if object == nil then object = self end
		local	position = cc.pAdd(object:getPosition(), event:getDelta())
--		local	position = cc.pAdd(object:getPosition(), event:getScroll())
		object:setPosition(position)
	end
end


function PlayerShade:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		self:setForeground()
--		self:setLocalZOrderForeground()
		event:setCapture(self)
		return true
	end
end


function PlayerShade:onMouseUp(
	event
	)
	if event:isCapture(self) then
		event:removeCapture()
		return true
	end
end


function PlayerShade:buttonOnForeground(
	button,
	event
	)
	
	-- őOʂ
	self:setForeground()
	
end

function PlayerShade:buttonTitlebarMark(
	-- }[NNbN
	button
	)
	-- őOʂ
--	self:setForeground()
	
	love.system.openURL("http://studiopixel.jp/pxtone/")
end

function PlayerShade:buttonTitlebarMinisize(
	-- ŏ
	button
	)
	
	self:getParent():setVisible(false)
end


function PlayerShade:buttonTitlebarShade(
	-- e
	button
	)
	local	master = self:getMaster()
	if master then
		master:setShade(false)
	end
end


function PlayerShade:buttonTitlebarClose(
	-- 
	button
	)
	
	self:getParent():setVisible(false)
end


function PlayerShade:buttonPlaybackPrev(
	-- ߂鏈
	button
	)
	self:getScene():getAudioList():prev()
end


function PlayerShade:buttonPlaybackPlay(
	-- Đ
	button
	)
	self:getScene():getAudioList():play()
end


function PlayerShade:buttonPlaybackPause(
	-- ꎞ~
	button
	)
	self:getScene():getAudioList():pause()
end


function PlayerShade:buttonPlaybackStop(
	-- ~
	button
	)
	self:getScene():getAudioList():stop()
end


function PlayerShade:buttonPlaybackNext(
	-- ւ̏
	button
	)
	self:getScene():getAudioList():next()
end

function PlayerShade:buttonOpenFile(
	-- t@CI[v
	button
	)
	love.system.openURL("http://studiopixel.jp/pxtone/")
end



function PlayerShade:update(dt)
	
	Slave.update(self, dt)
	
	local	background = self:getChildByName("background")
	if background then
		if self:isForeground() then
			-- eőOʂɂꍇ
			background:setTextureRect(cc.rect(27, 29, 275, 14))
		else
			background:setTextureRect(cc.rect(27, 42, 275, 14))
		end
	end
end



return PlayerShade
