local	Posbar = {}
Posbar = class("PlayerShade.Posbar", cc.Layer)

function Posbar:ctor(...)
	cc.Layer.ctor(self, ...)
	self:setContentSize(cc.size(17, 7))
	
	-- wi
	do
		local	sprite = cc.Sprite:create(
			"res/skins/pxtone/TITLEBAR.bmp",
			cc.rect(0, 36, 17, 7)
		)
		sprite:setPosition(
			self:getContentSize().width * 0.5,
			self:getContentSize().height * 0.5
		)
		self:addChild(sprite)
	end
	
	-- XCh{[
	do
		local	slidBall = cc.Sprite:create()
		slidBall:initWithFile("res/skins/pxtone/TITLEBAR.bmp", cc.rect(17, 36, 3, 7))
		slidBall:setPosition(slidBall:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		slidBall:setName("slidBall")
--		slidBall:setVisible(false)
		self:addChild(slidBall)
	end
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end

function Posbar:setPosper(
	posper
	)
	local	slidBall = self:getChildByName("slidBall")
	if slidBall then
		slidBall:setPosition(
			slidBall:getContentSize().width * 0.5 +
			(self:getContentSize().width - slidBall:getContentSize().width) * posper,
			self:getContentSize().height * 0.5
		)
	end
end

function Posbar:getPosper()
	-- XCh{[|WVp[ZgZo
	local	slidBall = self:getChildByName("slidBall")
	if slidBall then
		local	slidBallWidth = slidBall:getContentSize().width
		local	posx = slidBall:getPosition().x - slidBallWidth * 0.5
		local	posper = posx / (self:getContentSize().width - slidBallWidth)
		if posper < 0 then posper = 0 end
		if posper > 1 then posper = 1 end
		return posper
	end
	
end


function Posbar:onMouseMove(
	event
	)
	local	slidBall = self:getChildByName("slidBall")
	if event:isCapture(self) and slidBall then
		local	slidBallWidth = slidBall:getContentSize().width
		local	boundingBox = self:getBoundingBox()
		local	posx = event:getLocation().x - boundingBox.x - slidBallWidth * 0.5
		
		self.m_seekPosper = posx / (boundingBox.width - slidBallWidth)
		if self.m_seekPosper < 0 then self.m_seekPosper = 0 end
		if self.m_seekPosper > 1 then self.m_seekPosper = 1 end
		
		self:getScene():getAudioList():setSeekPosbarPercent(self.m_seekPosper)
		
--		self:setPosper(self.m_seekPosper)
	end
end


function Posbar:onMouseDown(
	event
	)
	
	local	audioManager = self:getScene():getAudioManager()
	local	source = nil
	if audioManager then source = audioManager:getSource() end
	if source and source:isStopped() == false then
		if self:isHover(event:getLocation()) then
			
			-- eőOʂ
			self:getParent():setForeground()
--			self:getParent():setLocalZOrderForeground()
			
			local	slidBall = self:getChildByName("slidBall")
			if slidBall then
				-- ANeBu
--				slidBall:setTextureRect(cc.rect(278, 0, 29, 10))
			end
			self.m_seekPosper = self:getPosper()
			self:getScene():getAudioList():setSeekPosbarPercent(self.m_seekPosper)
			self:getScene():getAudioList():setSeekPosbar(true)
			event:setCapture(self)
			return true
		end
	end
end


function Posbar:onMouseUp(
	event
	)
	if event:isCapture(self) then
		
		local	audioManager = self:getScene():getAudioManager()
		
		local	slidBall = self:getChildByName("slidBall")
		if slidBall then
			-- |WeBu
--			slidBall:setTextureRect(cc.rect(248, 0, 29, 10))
		end
		
		-- ꏊړ
		if audioManager then
			local	source = audioManager:getSource()
			local	soundStatus = audioManager:getSoundStatus()
			if self.m_seekPosper and source and soundStatus then
				local	sample = soundStatus.sampleCount * self.m_seekPosper
				if self.m_seekPosper == 1 then
					sample = sample - 1
				end
				source:seek(sample, "samples")
			end
		end
		
		event:removeCapture()
		self:getScene():getAudioList():setSeekPosbar(false)
		
		self.m_seekPosper = nil
		return true
	end
end


function Posbar:update(dt)
	local	slidBall = self:getChildByName("slidBall")
	
	if slidBall then
		local	posper = self:getScene():getAudioList():getPosper()
		
		if posper == nil then
			slidBall:setVisible(false)
		else
			slidBall:setVisible(true)
			
			if posper > 0.66 then
				slidBall:setTextureRect(cc.rect(17 + 3 * 2, 36, 3, 7))
			elseif posper > 0.33 then
				slidBall:setTextureRect(cc.rect(17 + 3 * 1, 36, 3, 7))
			else
				slidBall:setTextureRect(cc.rect(17 + 3 * 0, 36, 3, 7))
			end
			
			self:setPosper(posper)
		end
	end
end


return Posbar
