local	Pledit = {}

local	Slave = import("..Components.Slave")
local	Pledit_MainTop = import(".Pledit_MainTop")
local	Pledit_MainMiddle = import(".Pledit_MainMiddle")
local	Pledit_MainBottom = import(".Pledit_MainBottom")

Pledit = class("Pledit", Slave)

function Pledit:ctor(...)
	Slave.ctor(self, ...)
--	ccui.Layout.ctor(self, ...)
	
	-- fobO\
--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.gradient)
	
--	self:setContentSize(cc.size(275, 116))
	
end

function Pledit:onEnter()
	
	local	page = self:getScene():getAudioList():getScrollPage()
	
	self:setContentSize(cc.size(275, 20 + page * 14 + 2 + 38))
	
	-- 
	do
		local	mainTop = Pledit_MainTop:create()
		mainTop:setPosition(cc.p(0, 0))
		mainTop:setName("mainTop")
		self:addChild(mainTop)
	end
	
	-- 
	do
		local	mainMiddle = Pledit_MainMiddle:create()
		mainMiddle:setPosition(cc.p(0, 20))
		mainMiddle:setName("mainMiddle")
		self:addChild(mainMiddle)
	end
	
	-- 
	do
		local	mainBottom = Pledit_MainBottom:create()
		mainBottom:setPosition(cc.p(0, self:getContentSize().height - mainBottom:getContentSize().height))
		mainBottom:setName("mainBottom")
		self:addChild(mainBottom);
	end
	
	
	do
		local	eventMouse = cc.EventMouse:create()
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		eventMouse.onScroll = self.onScroll
		
		self:addEventListener(
			eventMouse
		) 
	end
end

function Pledit:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	object = self:getMaster()
		if object == nil then object = self end
		local	position = cc.pAdd(object:getPosition(), event:getDelta())
--		local	position = cc.pAdd(object:getPosition(), event:getScroll())
		object:setPosition(position)
	end
end


function Pledit:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		self:setForeground()
		event:setCapture(self)
		return true
	end
end


function Pledit:onMouseUp(
	event
	)
	if event:isCapture(self) then
		event:removeCapture()
		return true
	end
end


function Pledit:onScroll(
	event
	)
	
	if self:isHover(event:getLocation()) and self:isForeground() then
		local	audioList = self:getScene():getAudioList()
		
		if audioList then
			if event:getScroll().y > 0 then
				audioList:prevSelectedPosition()
			elseif event:getScroll().y < 0 then
				audioList:nextSelectedPosition()
			end
		end
	end
end

function Pledit:onReload()
	
	local	mainMiddle = self:getChildByName("mainMiddle")
	if mainMiddle then
		mainMiddle:onReload()
	end
end


function Pledit:onResize()
	-- TCY𑣂
	
	
	local	page = self:getScene():getAudioList():getScrollPage()
	self:setContentSize(cc.size(275, 20 + page * 14 + 2 + 38))
	self:getParent():setContentSize(self:getContentSize())
	do
		local	mainBottom = self:getChildByName("mainBottom")
		if mainBottom then
			mainBottom:setPosition(cc.p(0, self:getContentSize().height - mainBottom:getContentSize().height - 1))
		end
	end
	do
		local	mainMiddle = self:getChildByName("mainMiddle")
		if mainMiddle then
			mainMiddle:onResize()
		end
	end
end

return Pledit

