local	Pledit_Column = {}
Pledit_Column = class("Pledit_Column", ccui.Layout)

function Pledit_Column:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self:setContentSize(cc.size(243, 14))
	
	do
		local	text = cc.Label:create()
		text:createWithTTF("",  "res/IPAexfont00301/ipaexg.ttf", 12)
		text:setName("text")
		self:addChild(text)
	end
	
	do
		local	button = ccui.Button:create()
		button:setContentSize(self:getContentSize())
		button:setPosition(self:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		button:setMouseEnabled(true, handler(self, handler(self, self.onClick)))
		button:setName("button")
		self:addChild(button)
	end
	
	self:scheduleUpdate()
end


function Pledit_Column:onEnter()
	-- ここに来たら文字が判るよ
	local	audioList = self:getScene():getAudioList()
	if audioList then
		local	audioManager = audioList:getPosAudioManager(self:getTag())
		text = self:getChildByName("text")
		if audioManager and text then
			-- テキストセット
			text:setString(audioManager:getName())
			text:setPosition(text:getContentSize().width * 0.5, text:getContentSize().height * 0.5)
		end
	end
end


function Pledit_Column:update(
	-- 更新処理
	dt
	)
	local	audioList = self:getScene():getAudioList()
	local	text = self:getChildByName("text")
	
	if audioList then
		-- 背景カーソル設定
		if audioList:getSelectedPosition() == self:getTag() then
			self:setBackGroundColorType(ccui.LayoutBackGroundColorType.gradient)
			self:setBackGroundColor(cc.c3b(0x40, 0x00, 0x70))
		else
			self:setBackGroundColorType(ccui.LayoutBackGroundColorType.none)
		end
		
		-- テキストカラー設定
		if text then
			if self:getTag() == audioList:getCurrentPosition() then
				-- カレント
				text:setTextColor(cc.c3b(0xf0, 0x80, 0x00))
			else
				-- ノーマル
				text:setTextColor(cc.c3b(0x00, 0xf0, 0x80))
			end
		end
	end
end


function Pledit_Column:onClick(
	button,
	event
	)
	
	self:getParent():getParent():getParent():getParent():setForeground()
	
	local	audioList = self:getScene():getAudioList()
	
	if audioList then
		if audioList:getSelectedPosition() ~= self:getTag() then
			-- 選択位置と違っていたら移動
			audioList:setSelectedPosition(self:getTag())
		else
			-- 一緒だったらその位置を再生
			audioList:playToPosition(self:getTag())
		end
	end
	
end


--Normal=#00f080
--Current=#f08000
--NormalBG=#00003e
--SelectedBG=#400070


return Pledit_Column
