
local	Pledit_Column = import(".Pledit_Column")

local	Pledit_List = {}
Pledit_List = class("Pledit_List", ccui.ListView)

function Pledit_List:ctor(...)
	ccui.ListView.ctor(self, ...)
	
	
	self:scheduleUpdate()
	
	do
		local	eventKeyboard = cc.EventKeyboard:create()
		
		eventKeyboard.keyPressed = self.keyPressed
		eventKeyboard.keyReleased = self.keyReleased
		
		self:addEventListener(
			eventKeyboard
		)
	end
end

function Pledit_List:onEnter()
	
	-- ɂĂ݂H
	self:onReload()
--	local	page = self:getScene():getAudioList():getScrollPage()
--	
--	self:setContentSize(cc.size(243, page * 14))
--	
--	local	audioList = self:getScene():getAudioList()
--	for i = 1, audioList:getListCount() do
--		local	column = Pledit_Column:create()
--		column:setTag(i)
--		column:setContentSize(cc.size(self:getContentSize().width, 14))
--		self:pushBackCustomItem(column)
--	end
end


function Pledit_List:onReload()
	
	
	self:removeAllItems()
	
	local	page = self:getScene():getAudioList():getScrollPage()
	
	self:setContentSize(cc.size(243, page * 14))
	
	local	audioList = self:getScene():getAudioList()
	for i = 1, audioList:getListCount() do
		local	column = Pledit_Column:create()
--		column:setTag(i)
		column:setContentSize(cc.size(self:getContentSize().width, 14))
		self:pushBackCustomItem(column)
	end
	self:getInnerContainer():cleanup()
end

function Pledit_List:scrollCallback(
	audioList
	)
	if audioList then
		local	max = #audioList:getList() - audioList.m_scrollPage
		self:jumpToPercentVertical((audioList.m_scrollPos - 1) / max)
	end
end


function Pledit_List:keyPressed(
	event
	)
	
	if self:getParent():getParent():isForeground() then
		local	key, isrepeat = event:getKey()
		local	audioList = self:getScene():getAudioList()
		
		if audioList then
			if key == "up" then
				audioList:prevSelectedPosition()
				return true
			elseif key == "down" then
				audioList:nextSelectedPosition()
				return true
			elseif key == "return" then
				audioList:playToPosition(audioList:getSelectedPosition())
				return true
			end
		end
	end
end

function Pledit_List:keyReleased(
	event
	)
end


function Pledit_List:update(dt)
	-- bI
	local	audioList = self:getScene():getAudioList()
	if audioList then
		self:scrollCallback(audioList)
	end
end

function Pledit_List:onResize()
	
	local	page = self:getScene():getAudioList():getScrollPage()
	
	self:setContentSize(cc.size(243, page * 14))
	
	
	
end

return Pledit_List
