
local	Slave = import("..Components.Slave")
local	Numbers_Minus = import(".Numbers_Minus")
local	Numbers_Minute = import(".Numbers_Minute")
local	Numbers_Second = import(".Numbers_Second")
local	Numbers_TimeReverse = import(".Numbers_TimeReverse")
local	Pledit_Resize = import(".Pledit_Resize")


local	Pledit_MainBottom = {}
Pledit_MainBottom = class("Pledit_MainBottom", Slave)

function Pledit_MainBottom:ctor(...)
	Slave.ctor(self, ...)
	self:setContentSize(cc.size(275, 38))
	
	-- inj
	do
		local	image = cc.Sprite:create()
		local	rect = cc.rect(0, 72, 125, 38)
		local	position = cc.rect(0, 0, rect.width, rect.height)
		image:initWithFile("res/skins/pxtone/PLEDIT.bmp", rect)
		image:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(image)
	end
	
	-- Einj
	do
		local	image = cc.Sprite:create()
		local	rect = cc.rect(126, 72, 150, 38)
		local	position = cc.rect(0, 0, rect.width, rect.height)
		image:initWithFile("res/skins/pxtone/PLEDIT.bmp", rect)
		image:setPosition(self:getContentSize().width - rect.width + cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addChild(image)
	end
	
	-- 
	do
		local	button = ccui.Button:create()
		local	position = cc.rect(260, 2, 8, 5)
		button:setContentSize(cc.size(position.width, position.height))
		button:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		button:setMouseEnabled(
			true,
			{
				onClick = handler(self, self.lineUp),
				onDown = handler(self, self.buttonOnForeground),
				onUp = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	-- 
	do
		local	button = ccui.Button:create()
		local	position = cc.rect(260, 7, 8, 5)
		button:setContentSize(cc.size(position.width, position.height))
		button:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		button:setMouseEnabled(
			true,
			{
				onClick = handler(self, self.lineDown),
				onDown = handler(self, self.buttonOnForeground),
				onUp = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	
	-- e{^
	local	buttons = {
			-- O
			{
				size = cc.size(7, 8),
				position = cc.rect(131, 23, 7, 8),
				onClick = handler(self, self.buttonPlaybackPrev)
			},
			-- Đ
			{
				size = cc.size(10, 8),
				position = cc.rect(138, 23, 10, 8),
				onClick = handler(self, self.buttonPlaybackPlay)
			},
			-- |[Y
			{
				size = cc.size(10, 8),
				position = cc.rect(148, 23, 10, 8),
				onClick = handler(self, self.buttonPlaybackPause)
			},
			-- ~
			{
				size = cc.size(9, 8),
				position = cc.rect(158, 23, 9, 8),
				onClick = handler(self, self.buttonPlaybackStop)
			},
			-- 
			{
				size = cc.size(9, 8),
				position = cc.rect(167, 23, 9, 8),
				onClick = handler(self, self.buttonPlaybackNext)
			},
			-- t@CI[v
			{
				size = cc.size(9, 8),
				position = cc.rect(176, 23, 9, 8),
				onClick = handler(self, self.buttonOpenFile)
			},
	}
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onDown = handler(self, self.buttonOnForeground),
				onUp = handler(self, self.buttonOnForeground),
			}
		)
		self:addChild(button)
	end
	
	
	-- io[Y
	do
		local	minus = Numbers_Minus:create()
		local	position = cc.rect(193, 23, 5, 6)
		minus:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(minus)
	end
	
	-- 
	do
		local	numbers_minute = Numbers_Minute:create()
		local	rect = cc.rect(198, 23, 10, 6)
		numbers_minute:setPosition(cc.rectGetMidX(rect), cc.rectGetMidY(rect))
		self:addNumber(numbers_minute)
	end
	
	-- b
	do
		local	numbers_second = Numbers_Second:create()
		local	rect = cc.rect(211, 23, 10, 6)
		numbers_second:setPosition(cc.rectGetMidX(rect), cc.rectGetMidY(rect))
		self:addNumber(numbers_second)
	end
	
	-- ]
	do
		local	timeReverse = Numbers_TimeReverse:create()
		local	position = cc.rect(190, 23, 30, 6)
		timeReverse:setPosition(cc.rectGetMidX(position), cc.rectGetMidY(position))
		self:addNumber(timeReverse)
	end
	
	-- TCY
	do
		local	resize = Pledit_Resize:create()
		local	position = cc.rect(256, 19, 19, 19)
		resize:setPosition(position.x, position.y)
		self:addChild(resize)
	end
end

function Pledit_MainBottom:lineUp(
	button,
	event
	)
	local	audioList = self:getScene():getAudioList()
	if audioList then
		audioList:prevSelectedPosition()
	end
end

function Pledit_MainBottom:lineDown(
	button,
	event
	)
	local	audioList = self:getScene():getAudioList()
	if audioList then
		audioList:nextSelectedPosition()
	end
end

function Pledit_MainBottom:buttonOnForeground(
	button,
	event
	)
	
	-- őOʂ
	self:getParent():setForeground()
end



function Pledit_MainBottom:buttonPlaybackPrev(
	-- ߂鏈
	button
	)
	self:getScene():getAudioList():prev()
end


function Pledit_MainBottom:buttonPlaybackPlay(
	-- Đ
	button
	)
	self:getScene():getAudioList():play()
end


function Pledit_MainBottom:buttonPlaybackPause(
	-- ꎞ~
	button
	)
	self:getScene():getAudioList():pause()
end


function Pledit_MainBottom:buttonPlaybackStop(
	-- ~
	button
	)
	self:getScene():getAudioList():stop()
end


function Pledit_MainBottom:buttonPlaybackNext(
	-- ւ̏
	button
	)
	self:getScene():getAudioList():next()
end


function Pledit_MainBottom:buttonOpenFile(
	-- I[v
	button
	)
	
	love.system.openURL("http://pistonsource.agargara.com/")
end




return Pledit_MainBottom


