local	Pledit_Posbar = {}
Pledit_Posbar = class("Pledit.Posbar", cc.Layer)

function Pledit_Posbar:ctor(...)
	cc.Layer.ctor(self, ...)
	
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end

function Pledit_Posbar:onEnter()
	local	page = self:getScene():getAudioList():getScrollPage()
	
	-- TCYݒ
	self:setContentSize(cc.size(8, page * 14))
	
	-- XCh{[
	do
		local	slidBall = cc.Sprite:create()
		
		-- 52,53,8,18
		-- 61,53,8,18
		slidBall:initWithFile("res/skins/pxtone/PLEDIT.bmp", cc.rect(52, 53, 8, 18))
		slidBall:setPosition(self:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
		slidBall:setName("slidBall")
		self:addChild(slidBall)
	end
end


function Pledit_Posbar:getPosper()
	local	slidBall = self:getChildByName("slidBall")
	local	audioList = self:getScene():getAudioList()
	local	posper = nil
	if slidBall then
		if audioList and audioList:getListCount() > audioList:getScrollPage() then
			local	totalCount = audioList:getListCount() - audioList:getScrollPage() + 1
			posper = (audioList:getScrollPosition() - 1) / (totalCount - 1)
		end
	end
	return posper
end


function Pledit_Posbar:onMouseMove(
	event
	)
	
	local	slidBall = self:getChildByName("slidBall")
	if event:isCapture(self) and slidBall:isVisible() then
		local	slidBallHeight = slidBall:getContentSize().height
		local	boundingBox = self:getBoundingBox()
		local	posy = event:getLocation().y - boundingBox.y - slidBallHeight * 0.5
		
		local	posper = posy / (boundingBox.height - slidBallHeight)
		if posper < 0 then posper = 0 end
		if posper > 1 then posper = 1 end
		
		do
			local	audioList = self:getScene():getAudioList()
			local	totalCount = audioList:getListCount() - audioList:getScrollPage() + 1
			local	scrollPos = math.floor((totalCount - 1) * posper) + 1
			audioList:setScrollPosition(scrollPos)
		end
	end
	
	
--	local	slidBall = self:getChildByName("slidBall")
--	if event:isCapture(self) and slidBall then
--		local	slidBallWidth = slidBall:getContentSize().width
--		local	boundingBox = self:getBoundingBox()
--		local	posx = event:getLocation().x - boundingBox.x - slidBallWidth * 0.5
--		
--		self.m_seekPosper = posx / (boundingBox.width - slidBallWidth)
--		if self.m_seekPosper < 0 then self.m_seekPosper = 0 end
--		if self.m_seekPosper > 1 then self.m_seekPosper = 1 end
--		
--		self:getScene():setSeekPosbarPercent(self.m_seekPosper)
--	end
end


function Pledit_Posbar:onMouseDown(
	event
	)
	
	if self:isHover(event:getLocation()) then
			-- eőOʂ
			self:getParent():getParent():setForeground()
			
			local	slidBall = self:getChildByName("slidBall")
			if slidBall then
				-- ANeBu
				slidBall:setTextureRect(cc.rect(52 + 9, 53, 8, 18))
			end
			event:setCapture(self)
			return true
	end
	
--	local	audioManager = self:getScene():getAudioManager()
--	local	source = nil
--	if audioManager then source = audioManager:getSource() end
--	if source and source:isStopped() == false then
--		if self:isHover(event:getLocation()) then
--			
--			-- eőOʂ
--			self:getParent():setForeground()
--			
--			local	slidBall = self:getChildByName("slidBall")
--			if slidBall then
--				-- ANeBu
--				slidBall:setTextureRect(cc.rect(278, 0, 29, 10))
--			end
--			self.m_seekPosper = self:getPosper()
--			self:getScene():setSeekPosbarPercent(self.m_seekPosper)
--			self:getScene():setSeekPosbar(true)
--			event:setCapture(self)
--			return true
--		end
--	end
end


function Pledit_Posbar:onMouseUp(
	event
	)
	if event:isCapture(self) then
		local	slidBall = self:getChildByName("slidBall")
		if slidBall then
			-- |WeBu
			slidBall:setTextureRect(cc.rect(52, 53, 8, 18))
		end
		
		event:removeCapture()
	end
	
--	if event:isCapture(self) then
--		
--		local	audioManager = self:getScene():getAudioManager()
--		
--		local	slidBall = self:getChildByName("slidBall")
--		if slidBall then
--			-- |WeBu
--			slidBall:setTextureRect(cc.rect(248, 0, 29, 10))
--		end
--		
--		-- ꏊړ
--		if audioManager then
--			local	source = audioManager:getSource()
--			local	soundStatus = audioManager:getSoundStatus()
--			if self.m_seekPosper and source and soundStatus then
--				local	sample = soundStatus.sampleCount * self.m_seekPosper
--				if self.m_seekPosper == 1 then
--					sample = sample - 1
--				end
--				source:seek(sample, "samples")
--			end
--		end
--		
--		event:removeCapture()
--		self:getScene():setSeekPosbar(false)
--		
--		self.m_seekPosper = nil
--		return true
--	end
end



function Pledit_Posbar:update(dt)
	local	slidBall = self:getChildByName("slidBall")
	
	if slidBall then
		local	posper = self:getPosper()
		if posper then
			slidBall:setPosition(
				self:getContentSize().width * 0.5,
				slidBall:getContentSize().height * 0.5 +
					(self:getContentSize().height - slidBall:getContentSize().height) * posper
			)
			slidBall:setVisible(true)
		else
			slidBall:setVisible(false)
		end
	end
	
--	local	slidBall = self:getChildByName("slidBall")
--	local	audioList = self:getScene():getAudioList()
--	
--	if slidBall then
--		if audioList and audioList:getListCount() > audioList:getScrollPage() then
--			local	totalCount = audioList:getListCount() - audioList:getScrollPage() + 1
--			local	per = (audioList:getScrollPosition() - 1) / (totalCount - 1)
--			
--			slidBall:setPosition(
--				self:getContentSize().width * 0.5,
--				slidBall:getContentSize().height * 0.5 +
--					(self:getContentSize().height - slidBall:getContentSize().height) * per
--			)
--			
--			slidBall:setVisible(true)
--		else
--			slidBall:setVisible(false)
--		end
--	end
end

function Pledit_Posbar:onResize()
	local	page = self:getScene():getAudioList():getScrollPage()
	-- TCYݒ
	self:setContentSize(cc.size(8, page * 14))
	self:update()
end

return Pledit_Posbar
