
local	Pledit_Resize = {}

Pledit_Resize = class("Pledit_Resize", cc.Node)

function Pledit_Resize:ctor(...)
	cc.Node.ctor(self, ...)
	self:setContentSize(cc.size(19, 19))
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
end

function Pledit_Resize:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	audioList = self:getScene():getAudioList()
		local	location = self:getParent():getParent():convertToNodeSpace(event:getLocation())
		local	page = math.floor((location.y - 116 + self:getContentSize().height) / 14)
		if page < 0 then page = 0 end
		page = page + 4
		
		if audioList:getScrollPage() ~= page then
			audioList:setScrollPage(page)
			audioList:scrollRefresh()
			self:getParent():getParent():onResize()
		end
	end
end

function Pledit_Resize:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		
		-- J[\Zbg
		if love.mouse.hasCursor() then
			love.mouse.setCursor(love.mouse.getSystemCursor("sizens"))
		end
		
		self:getParent():getParent():setForeground()
		event:setCapture(self)
		return true
	end
end

function Pledit_Resize:onMouseUp(
	event
	)
	if event:isCapture(self) then
		
		-- J[\
		if love.mouse.hasCursor() then
			love.mouse.setCursor()
		end
		
		event:removeCapture()
		return true
	end
end

return Pledit_Resize

