
local	Background = import(".Background")
local	Text_Name = import(".Text_Name")
local	Slave = import("..Components.Slave")

local	PleditShade = {}
PleditShade = class("PleditShade", Slave)

function PleditShade:ctor(...)
	Slave.ctor(self, ...)
	self:setContentSize(cc.size(275, 14))
	
	do
		local	background = Background:create()
		self:addChild(background)
	end
	
	-- e{^
	local	buttons = {
		-- ^Cgo[֘A
		-- e
		{
			size = cc.size(9, 9),
			position = cc.rect(254, 3, 9, 9),
			normal = "res/skins/pxtone/PLEDIT.bmp",
			normalRect = cc.rect(128, 45, 9, 9),
			selected = "res/skins/pxtone/PLEDIT.bmp",
			selectedRect = cc.rect(150, 42, 9, 9),
			onClick = handler(self, self.buttonTitlebarShade)
		},
		-- 
		{
			size = cc.size(9, 9),
			position = cc.rect(264, 3, 9, 9),
			normal = "res/skins/pxtone/PLEDIT.bmp",
			normalRect = cc.rect(138, 45, 9, 9),
			selected = "res/skins/pxtone/PLEDIT.bmp",
			selectedRect = cc.rect(52, 42, 9, 9),
			onClick = handler(self, self.buttonTitlebarClose)
		},
	}
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		if bs.size then
			-- TCY
			button:setContentSize(bs.size)
		end
		if bs.position then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.rectGetMidX(bs.position), cc.rectGetMidY(bs.position))
		end
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
				onDown = handler(self, self.buttonOnForeground),
				onUp = handler(self, self.buttonOnForeground),
				
			}
		)
		self:addChild(button)
	end
	
	-- eLXg
	do
		local	text_name = Text_Name:create()
		local	position = cc.rect(4, 2, 242, 10)
		text_name:setPosition(4, 2)
		self:addChild(text_name)
	end
	
	do
		local	eventMouse = cc.EventMouse:create()
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
end


function PleditShade:onMouseMove(
	event
	)
	if event:isCapture(self) then
		local	object = self:getMaster()
		if object == nil then object = self end
		local	position = cc.pAdd(object:getPosition(), event:getDelta())
--		local	position = cc.pAdd(object:getPosition(), event:getScroll())
		object:setPosition(position)
	end
end


function PleditShade:onMouseDown(
	event
	)
	if self:isHover(event:getLocation()) then
		self:setForeground()
		event:setCapture(self)
		return true
	end
end


function PleditShade:onMouseUp(
	event
	)
	if event:isCapture(self) then
		event:removeCapture()
		return true
	end
end

function PleditShade:buttonOnForeground(
	button,
	event
	)
	
	-- őOʂ
	self:setForeground()
end



function PleditShade:buttonTitlebarShade(
	-- e
	button
	)
	
	local	master = self:getMaster()
	if master then
		master:setShade(false)
	end
end


function PleditShade:buttonTitlebarClose(
	-- 
	button
	)
	self:getParent():setVisible(false)
end


return PleditShade

