local	TaskButton = import(".TaskButton")

local	TaskBar = {}

TaskBar = class("TaskBar", cc.LayerColor)


function TaskBar:ctor(...)
	cc.LayerColor.ctor(self, cc.c3b(78, 75, 97), ...)
end

function TaskBar:onEnter()
	-- {^\z
	
	do
		local	button = TaskButton:create()
		button:setContentSize(cc.size(88, 18))
		button:setPosition(
			4 + button:getContentSize().width * 0.5,
			self:getContentSize().height * 0.5
		)
		button:setLinkName("player")
		button:setActiveTexture(
			"res/AudioTest/player.bmp",
			cc.rect(0, 0, 88, 18)
		)
		button:setPositiveTexture(
			"res/AudioTest/player.bmp",
			cc.rect(0, 18, 88, 18)
		)
		self:addChild(button)
	end
	
	local	taskButtons = {
		{
			"mbPistonsource",
			"res/AudioTest/newminilogo.png",
		},
		{
			"mbAgargara",
			"res/AudioTest/d8df9a4a1fff9a1d10768fe56e37876f.png",
		},
		{
			"mbZebra",
			"res/AudioTest/mtPjz1B7.png",
		},
		{
			"mbYamahara",
			"res/AudioTest/default_profile_5.png",
		},
		{
			"mbPixel",
			"res/AudioTest/sS4XiCae.png",
		},
		{
			"mbPxtone",
			"res/AudioTest/gHmunznx.png",
		},
		{
			"mbLibs",
			"res/AudioTest/love2d.png",
		},
	}
	for index, tb in ipairs(taskButtons) do
		local	button = TaskButton:create()
		button:setContentSize(cc.size(18, 18))
		button:setPosition(
			96 + button:getContentSize().width * 0.5 + (index - 1) * 24,
			self:getContentSize().height * 0.5
		)
		button:setLinkName(tb[1])
		button:setActiveTexture(
			tb[2],
			cc.rect(0, 0, 18, 18)
		)
		button:setPositiveTexture(
			"res/AudioTest/positive.bmp",
			cc.rect(0, 0, 18, 18)
		)
		self:addChild(button)
	end
	
	-- FPS\
	do
		local	text = cc.Label:create()
		text:createWithTTF("", "res/IPAexfont00301/ipaexg.ttf", 12)
		text:setName("fps")
		text:setTextColor(cc.c3b(0x00, 0xf0, 0x80))
		self:addChild(text)
	end
	self:scheduleUpdate()
end

function TaskBar:update(dt)
	
	local	text = self:getChildByName("fps")
	if text then
		text:setString(string.format("%s", love.timer.getFPS()))
		text:setPosition(
			self:getContentSize().width - text:getContentSize().width * 0.5,
			self:getContentSize().height * 0.5
		)
	end
end

return TaskBar
