
local	AudioList = import(".Utils.AudioList")

local	MainLayer = import(".Main.MainLayer")
local	MobileLayer = import(".Mobile.MobileLayer")

local	Path = import(".Utils.Path")


local	MainScene = {}
MainScene = class("MainScene", cc.Scene)

function MainScene:ctor(...)
	cc.Scene.ctor(self, ...)
	
	self.m_audioList = AudioList:create()
	
	-- SIDE A
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/01 [Azargabra] - Azargabra.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/02 [Azargabra] - Polygamouse.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/03 [Azargabra] - Dinosaur Snack.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/04 [Azargabra] - Wattah.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/05 [Azargabra] - Tarn2.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/06 [Azargabra] - Tearorx.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/07 [Azargabra] - Eviscerate My Organs Please.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/08 [Azargabra] - Crueler Advance of Time.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/09 [Azargabra] - Ppyyrraammiidd.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side A/10 [Azargabra] - Kinkakuji.ogg")
	
	-- SIDE Z
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/01 [Azargabra] - Aquarium.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/02 [Azargabra] - Watermelon.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/03 [Azargabra] - Bubbles.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/04 [Azargabra] - Melody.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/05 [Azargabra] - Melody.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/06 [Azargabra] - Ohh.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/07 [Azargabra] - Wild Boar Stew.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/08 [Azargabra] - Rats.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/09 [Azargabra] - Sweet Bratwurst.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/10 [Azargabra] - Scoliosis.ogg")
	self.m_audioList:addFile("res/ps040mp3/[Azargabra] - (PS040) Zebrafish [2014] (mp3)/Side Z/11 [Azargabra] - 16m.ogg")
	
--	do
--		local	layer = MainLayer:create()
--		layer:setName("mainLayer")
--		self:addChild(layer)
--	end
	
	if self:checkMobile() then
		-- 9:16 にすげ変えてみる
		do
			local	winSize = self:getContentSize()
			local	resolution = cc.size(16, 9)
			local	cell = math.min(winSize.width / resolution.width, winSize.height / resolution.height)
			local	layer = MobileLayer:create()
			layer:setContentSize(cc.size(cell * resolution.width, cell * resolution.height))
			layer:setPosition(
				(self:getContentSize().width - layer:getContentSize().width) * 0.5,
				(self:getContentSize().height - layer:getContentSize().height) * 0.5
			)
			self:addChild(layer)
		end
	else
		local	layer = MainLayer:create()
		layer:setName("mainLayer")
		self:addChild(layer)
	end
	
	
	self:scheduleUpdate()
end


function MainScene:getAudioManager()
	return self.m_audioList:getCurrentAudioManager()
end


function MainScene:getAudioList()
	return self.m_audioList
end


function MainScene:update(...)
	
	self.m_audioList:update(...)
end


function MainScene:checkMobile()
	local	os = love.system.getOS()
	local	bl = false
	if os == "Android" or os == "iOS" then
		bl = true
	end
	return bl
end

function MainScene:checkAudioFormat(
	ext
	)
	
	local	exts = {
		"wav",
		"mp3",
		"ogg",
		"oga2",
		"ogv",
		"699",
		"amf",
		"ams",
		"dbm",
		"dmf",
		"dsm",
		"far",
		"it" ,
		"j2b" ,
		"mdl" ,
		"med" ,
		"mod" ,
		"mt2" ,
		"mtm" ,
		"okt" ,
		"psm" ,
		"s3m" ,
		"stm" ,
		"ult" ,
		"umx",
		"xm",
		"abc",
		"mid",
		"pat"
	}
	for i = 1, #exts do
		if exts[i] == ext then
			return true
		end
	end
	return false
end


function MainScene:filedropped(file)
	-- ファイルを取得
	local	filename = file:getFilename()
	local	ext = string.lower(Path:getExtension(filename))
	
	if self:getAudioList() and self:checkAudioFormat(ext) then
		self:getAudioList():addFile(filename, file)
		-- りろーどをうながす？
		local	layer = self:getChildByName("mainLayer")
		if layer and type(layer.onReload) == "function" then layer:onReload() end
	end
end


return MainScene

