local	ControlLayer = {}
ControlLayer = class("ControlLayer", cc.Layer)


function ControlLayer:ctor(...)
	cc.LayerColor.ctor(self, ...)
end


function ControlLayer:onEnter()
	local	winSize = self:getContentSize()
	local	winCenter = cc.p(winSize.width * 0.5, winSize.height * 0.5)
	local	buttonContentSize = cc.size(0, 0)
	
	buttonContentSize.height = math.floor(winSize.height / 3)
	buttonContentSize.width = math.floor(buttonContentSize.height / 23 * 18)
	
	local	buttons = {
			-- Đ֘A
			-- ߂
			{
				name = "prev",
				posshift = 1,
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 0, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 0, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPrev),
				visible = true,
			},
			-- Đ
			{
				name = "play",
				posshift = 0,
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 1, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 1, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPlay),
				visible = true,
			},
			-- ꎞ~
			{
				name = "pause",
				posshift = 0,
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 2, 0, 23, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 2, 18, 23, 18),
				onClick = handler(self, self.buttonPlaybackPause),
				visible = false
			},
			-- 
			{
				name = "next",
				posshift = -1,
				normal = "res/skins/pxtone/CBUTTONS.bmp",
				normalRect = cc.rect(23 * 4, 0, 22, 18),
				selected = "res/skins/pxtone/CBUTTONS.bmp",
				selectedRect = cc.rect(23 * 4, 18, 22, 18),
				onClick = handler(self, self.buttonPlaybackNext),
				visible = true
			},
	}
	
	for index, bs in ipairs(buttons) do
		local	button = ccui.Button:create()
		if bs.name then
			button:setName(bs.name)
		end
		
		if bs.normal then
			-- WeLX`
			button:loadTextureNormal(
				bs.normal,
				bs.normalRect
			)
		end
		if bs.selected then
			-- IeLX`
			button:loadTextureSelected(
				bs.selected,
				bs.selectedRect
			)
		end
		
		do
			-- TCY
			button:setContentSize(buttonContentSize)
			
			-- 䗦ς
			button:setScale(button:getContentSize().width / 18, button:getContentSize().height / 23)
			button:setRotation(-90)
		end
		
		if bs.posshift then
			-- ʒui`FAJ[͒j
			button:setPosition(cc.pAdd(winCenter, cc.p(0, bs.posshift * button:getContentSize().height)))
		end
		
		if type(bs.visible) ~= nil then
			button:setVisible(bs.visible)
		end
		
		button:setMouseEnabled(true,
			{
				onClick = bs.onClick,
			}
		)
		self:addChild(button)
	end
	
	self:scheduleUpdate()
end

function ControlLayer:update(dt)
	local	audioManager = self:getScene():getAudioManager()
	local	source = nil
	local	buttonPlay = self:getChildByName("play")
	local	buttonPause = self:getChildByName("pause")
	
	if audioManager then source = audioManager:getSource() end
	if source and source:isPlaying() then
		buttonPlay:setVisible(false)
		buttonPause:setVisible(true)
	else
		buttonPlay:setVisible(true)
		buttonPause:setVisible(false)
	end
end


function ControlLayer:buttonPlaybackPrev(
	button
	)
	self:getScene():getAudioList():prev()
end


function ControlLayer:buttonPlaybackPlay(
	button
	)
	self:getScene():getAudioList():play()
end


function ControlLayer:buttonPlaybackPause(
	button
	)
	self:getScene():getAudioList():pause()
end


function ControlLayer:buttonPlaybackNext(
	button
	)
	self:getScene():getAudioList():next()
end


return ControlLayer
