local	Posbar = import(".Posbar")


local	FooterLayer = {}

FooterLayer = class("FooterLayer", cc.LayerColor)


function FooterLayer:ctor(...)
	cc.LayerColor.ctor(self, cc.c3b(0, 0, 62))
	
	self:scheduleUpdate()
end


function FooterLayer:onEnter()
	
	do
		local	posbar = Posbar:create()
		posbar:setContentSize(cc.size(self:getContentSize().width * 0.5, self:getContentSize().height * 0.6))
		posbar:setPosition(
			(self:getContentSize().width - posbar:getContentSize().width) * 0.5,
			(self:getContentSize().height - posbar:getContentSize().height) * 0.5
		)
		self:addChild(posbar)
	end
	
	do
		local	text = cc.Label:create()
		text:createWithTTF("", "res/IPAexfont00301/ipaexg.ttf", self:getParent().m_fontSize)
		text:setName("labelPlay")
		text:setTextColor(cc.c3b(0x00, 0xf0, 0x80))
		text:setPosition(
			(self:getContentSize().width) * 0.5,
			(self:getContentSize().height) * 0.9
		)
		text:setRotation(-90)
		self:addChild(text)
	end
	
	do
		local	text = cc.Label:create()
		text:createWithTTF("", "res/IPAexfont00301/ipaexg.ttf", self:getParent().m_fontSize)
		text:setName("labelDuration")
		text:setTextColor(cc.c3b(0x00, 0xf0, 0x80))
		text:setPosition(
			(self:getContentSize().width) * 0.5,
			(self:getContentSize().height) * 0.1
		)
		text:setRotation(-90)
		self:addChild(text)
	end
	
--	print(self:getContentSize().width, self:getContentSize().height)
end


function FooterLayer:update(dt)
	
	local	labelPlay = self:getChildByName("labelPlay")
	local	labelDuration = self:getChildByName("labelDuration")
	local	playTime = self:getScene():getAudioList():getPlayTime()
	local	audioManager = self:getScene():getAudioManager()
	local	soundStatus
	if audioManager then soundStatus = audioManager:getSoundStatus() end
	
	if labelPlay then
		if playTime then
			local	time = math.floor(playTime)
			local	minute = math.floor(time / 60 % 100)
			local	second = time % 60
			labelPlay:setString(string.format("%02d:%02d", minute, second))
		else
			labelPlay:setString("")
		end
	end
	
	if labelDuration and soundStatus then
		if playTime then
			local	time = math.floor(soundStatus.duration)
			local	minute = math.floor(time / 60 % 100)
			local	second = time % 60
			labelDuration:setString(string.format("%02d:%02d", minute, second))
		else
			labelDuration:setString("")
		end
	end
	
end


return FooterLayer

