local	HeaderLayer = {}

HeaderLayer = class("HeaderHayer", cc.LayerColor)

function HeaderLayer:ctor(...)
	cc.LayerColor.ctor(self, cc.c3b(0, 0, 62))
	
	
	self:scheduleUpdate()
end

function HeaderLayer:onEnter()
	do
		local	text = cc.Label:create()
		text:createWithTTF("", "res/IPAexfont00301/ipaexg.ttf", self:getParent().m_fontSize)
		text:setName("text")
		text:setTextColor(cc.c3b(0x00, 0xf0, 0x80))
		self:addChild(text)
	end
	
	do
		local	button = ccui.Button:create()
		button:loadTextureNormal(
			"res/skins/pxtone/TITLEBAR.bmp",
			cc.rect(18 + 9 * 0, 9 * 0, 9, 9)
		)
		button:loadTextureSelected(
			"res/skins/pxtone/TITLEBAR.bmp",
			cc.rect(18 + 9 * 0, 9 * 1, 9, 9)
		)
		
		-- TCY
		button:setContentSize(cc.size(self:getContentSize().width, self:getContentSize().width))
		
		button:setScale(button:getContentSize().width / 9, button:getContentSize().height / 9)
		button:setRotation(-90)
		
		button:setPosition(button:getContentSize().width * 0.5, button:getContentSize().height * 0.5)
		
		button:setMouseEnabled(true,
			{
				onClick = self.onButtonClose,
			}
		)
		
		self:addChild(button)
		
		
	end
	
end

function HeaderLayer:onButtonClose()
	-- I炷
	love.event.quit()
end

function HeaderLayer:update(dt)
	local	audioManager = self:getScene():getAudioManager()
	local	source = nil
	local	string = ""
	if audioManager then source = audioManager:getSource() end
	if self:getScene():getAudioList():isSeekVolume() == true then
		string = string.format(
			"Volume: %d%%",
			math.floor(love.audio.getVolume() * 100)
		)
	elseif source and source:isStopped() == false then
		if self:getScene():getAudioList():isSeekPosbar() == true then
			local	soundStatus = audioManager:getSoundStatus()
			
			local	per = self:getScene():getAudioList():getSeekPosbarPercent() or 0
			local	persecond = soundStatus.duration * per
			local	minsecond = math.floor(persecond % 60)
			local	minminute = math.floor(persecond / 60)
			local	maxsecond = math.floor(soundStatus.duration % 60)
			local	maxminute = math.floor(soundStatus.duration / 60)
			
			string = string.format(
				"Seek To: %d:%02d/%d:%02d(%d%%)",
				minminute,
				minsecond,
				maxminute,
				maxsecond,
				math.floor(per * 100)
			)
		elseif audioManager then
			string = audioManager:getName()
		else
			string = ""
		end
	else
		string = ""
	end
	
	if string then
		local	text = self:getChildByName("text")
		if text then
			text:setString(string)
			text:setPosition(
				self:getContentSize().width * 0.5,
				self:getContentSize().height - text:getContentSize().width * 0.5
			)
			text:setRotation(-90)
		end
	end
end



return HeaderLayer
