
local	HeaderLayer = import(".HeaderLayer")
local	ContentLayer = import(".ContentLayer")
local	ControlLayer = import(".ControlLayer")
local	FooterLayer = import(".FooterLayer")

local	MobileLayer = {}

MobileLayer = class("MobileLayer", cc.LayerColor)

function MobileLayer:ctor(...)
--	cc.LayerColor.ctor(self, cc.c3b(0, 0, 62))
	cc.LayerColor.ctor(self, cc.c3b(78, 75, 97))
end

function MobileLayer:onEnter()
	
	local	winSize = self:getContentSize()
	local	posx = 0
	
	self.m_fontSize = math.floor(winSize.height * 0.2 / 5)
	self.m_lineSize = math.floor(self.m_fontSize / 4)
	
	-- wb_[
	do
		local	header = HeaderLayer:create()
		header:setContentSize(cc.size(winSize.width / 16 * 1.5, winSize.height))
		self:addChild(header)
		
		posx = posx + header:getContentSize().width
	end
	
	-- Rec
	do
		local	content = ContentLayer:create()
		content:setContentSize(cc.size(winSize.width / 16 * 9.0, winSize.height))
		content:setPosition(posx, 0)
		self:addChild(content)
		
		posx = posx + content:getContentSize().width
	end
	
	-- Rg[
	do
		local	control = ControlLayer:create()
		control:setContentSize(cc.size(winSize.width / 16 * 4.0, winSize.height))
		control:setPosition(posx, 0)
		self:addChild(control)
		
		posx = posx + control:getContentSize().width
	end
	
	-- tb^[
	do
		local	posbar = FooterLayer:create()
		posbar:setContentSize(cc.size(winSize.width - posx, winSize.height))
		posbar:setPosition(posx, 0)
		self:addChild(posbar)
		
		posx = posx + posbar:getContentSize().width
	end
end


return MobileLayer

