local	Posbar = {}
Posbar = class("Posbar", ccui.Layout)

function Posbar:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self:setBackGroundColorType(2)
	self:setBackGroundColor(cc.c3b(52, 50, 85))
	
	do
		local	eventMouse = cc.EventMouse:create()
		
		eventMouse.onMouseMove = self.onMouseMove
		eventMouse.onMouseDown = self.onMouseDown
		eventMouse.onMouseUp = self.onMouseUp
		
		self:addEventListener(
			eventMouse
		)
	end
	
	self:scheduleUpdate()
end


function Posbar:onEnter()
	do
		local	slidBall = ccui.Layout:create()
		slidBall:setBackGroundColorType(2)
		slidBall.m_activeColor = cc.c3b(131, 126, 120)
		slidBall.m_positiveColor = cc.c3b(105, 101, 109)
		slidBall:setBackGroundColor(slidBall.m_positiveColor)
		slidBall:setName("slidBall")
		slidBall:setAnchorPoint(cc.p(0.5, 0.5))
		slidBall:setContentSize(cc.size(self:getContentSize().width, self:getContentSize().height / 20))
		self:addChild(slidBall)
	end
end


function Posbar:setPosper(
	posper
	)
	local	slidBall = self:getChildByName("slidBall")
	if slidBall then
		slidBall:setPosition(
			self:getContentSize().width * 0.5,
			slidBall:getContentSize().height * 0.5 +
			(self:getContentSize().height - slidBall:getContentSize().height) * (1 - posper)
		)
	end
end

function Posbar:getPosper()
	-- XCh{[|WVp[ZgZo
	local	slidBall = self:getChildByName("slidBall")
	if slidBall then
		local	slidBallHeight = slidBall:getContentSize().height
		local	posy = slidBall:getPosition().y - slidBallHeight * 0.5
		local	posper = posy / (self:getContentSize().height - slidBallHeight)
		if posper < 0 then posper = 0 end
		if posper > 1 then posper = 1 end
		return 1 - posper
	end
	
--	local	slidBall = self:getChildByName("slidBall")
--	if slidBall then
--		local	slidBallWidth = slidBall:getContentSize().width
--		local	posx = slidBall:getPosition().x - slidBallWidth * 0.5
--		local	posper = posx / (self:getContentSize().width - slidBallWidth)
--		if posper < 0 then posper = 0 end
--		if posper > 1 then posper = 1 end
--		return posper
--	end
end


function Posbar:onMouseMove(
	event
	)
	local	slidBall = self:getChildByName("slidBall")
	if event:isCapture(self) and slidBall then
		local	slidBallHeight = slidBall:getContentSize().height
		local	boundingBox = self:getBoundingBox()
		local	posy = event:getLocation().y - boundingBox.y - slidBallHeight * 0.5
		
		self.m_seekPosper = posy / (boundingBox.height - slidBallHeight)
		if self.m_seekPosper < 0 then self.m_seekPosper = 0 end
		if self.m_seekPosper > 1 then self.m_seekPosper = 1 end
		self.m_seekPosper = 1 - self.m_seekPosper
		
		self:getScene():getAudioList():setSeekPosbarPercent(self.m_seekPosper)
	end
end


function Posbar:onMouseDown(
	event
	)
	
	local	audioManager = self:getScene():getAudioManager()
	local	source = nil
	if audioManager then source = audioManager:getSource() end
	if source and source:isStopped() == false then
		if self:isHover(event:getLocation()) then
			
			
			local	slidBall = self:getChildByName("slidBall")
			if slidBall then
				-- ANeBu
				slidBall:setBackGroundColor(slidBall.m_activeColor)
--				slidBall:setTextureRect(cc.rect(278, 0, 29, 10))
			end
			self.m_seekPosper = self:getPosper()
			self:getScene():getAudioList():setSeekPosbarPercent(self.m_seekPosper)
			self:getScene():getAudioList():setSeekPosbar(true)
			event:setCapture(self)
			return true
		end
	end
end


function Posbar:onMouseUp(
	event
	)
	if event:isCapture(self) then
		
		local	audioManager = self:getScene():getAudioManager()
		
		local	slidBall = self:getChildByName("slidBall")
		if slidBall then
			-- |WeBu
			slidBall:setBackGroundColor(slidBall.m_positiveColor)
--			slidBall:setTextureRect(cc.rect(248, 0, 29, 10))
		end
		
		-- ꏊړ
		if audioManager then
			local	source = audioManager:getSource()
			local	soundStatus = audioManager:getSoundStatus()
			if self.m_seekPosper and source and soundStatus then
				local	sample = soundStatus.sampleCount * (self.m_seekPosper)
				if self.m_seekPosper == 1 then
					sample = sample - 1
				end
				source:seek(sample, "samples")
			end
		end
		
		event:removeCapture()
		self:getScene():getAudioList():setSeekPosbar(false)
		
		self.m_seekPosper = nil
		return true
	end
end


function Posbar:update(dt)
	local	slidBall = self:getChildByName("slidBall")
	
	if slidBall then
		local	posper = self:getScene():getAudioList():getPosper()
		if posper == nil then
			slidBall:setVisible(false)
		else
			slidBall:setVisible(true)
			
			self:setPosper(posper)
		end
	end
end


return Posbar
