local	Spectrum = {}
Spectrum = class("Spectrum", ccui.Layout)

function Spectrum:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self:setClippingType(1)
end


function Spectrum:draw(...)
	ccui.Layout.draw(self, ...)
	
	local	audioManager = self:getScene():getAudioManager()
	
	if audioManager and #audioManager:getSpectrum() > 0 then
		local	spectrum = audioManager:getSpectrum()
		local	margin = self:convertToWorldSpace(cc.p(0, 0))
		local	originColor = { love.graphics.getColor() }
		local	originLineWidth = love.graphics.getLineWidth()
		
		local	prev = cc.p(self:getContentSize().width * 0.5 + margin.x, self:getContentSize().height + margin.y)
		local	next = cc.p(self:getContentSize().width * 0.5 + margin.x ,self:getContentSize().height + margin.y)
		local	step = 256
		local	calcy = self:getContentSize().height / step
		
		love.graphics.setLineWidth(self:getParent():getParent().m_lineSize)
		for i = 1, step do
			next =  cc.p(
				self:getContentSize().width * 0.5 + margin.x + (-1 * spectrum[i]:get() * 0.5),
				self:getContentSize().height - (i * calcy - margin.y)
			)
			
			love.graphics.setColor(255 / step * i, 255 / step * i / 2, 255 - 255 / step * i)
			
			love.graphics.line(prev.x, prev.y, next.x, next.y)
			
			prev = next
		end
		
		love.graphics.setLineWidth(originLineWidth)
		love.graphics.setColor(unpack(originColor))
	end
end


return Spectrum

