local	AudioManager = import(".AudioManager")

local	AudioList = {}
AudioList = class("AudioList")


function AudioList:ctor(...)
	self.m_list = {}
	self.m_playing = false
	
	self.m_currentPos = nil		-- Đʒu
	
	self.m_selectedPos = nil	-- IʒuiXgw肵肷j
	
	self.m_scrollPage = 4	-- XN[`y[W
	self.m_scrollPos = 1	-- XN[`ʒu
	
	self.m_looping = false
	
	
	-- |WVV[N
	self.m_seekPosbar = false
	self.m_seekPosbarPercent = nil
	
	-- {[V[N
	self.m_seekVolume = false
	
	-- |WVp[ZgiV[N{[𑍍Ǘj
	self.m_posper = nil
	
	-- Ԕ]邩ǂ
	self.m_timeReverse = false
	
	self.m_playTime = nil
	self.m_stopTime = 0
end


function AudioList:isLooping()
	return self.m_looping
end


function AudioList:setLooping(looping)
	self.m_looping = looping
end


function AudioList:isPlaying()
	return self.m_playing
end


function AudioList:addFile(
	filename,
	file
	)
	if love.filesystem.isFile(filename) or file then
		local	audioManager = AudioManager:create()
		audioManager:setFile(filename, file)
		table.insert(self.m_list, audioManager)
	end
end



function AudioList:getSelectedPosition()
	return self.m_selectedPos
end


function AudioList:setSelectedPosition(
	selectedPos,
	scrollRefresh
	)
	self.m_selectedPos = selectedPos
	if scrollRefresh then
		self:scrollRefresh()
	end
end

function AudioList:setScrollPage(
	scrollPage
	)
	self.m_scrollPage = scrollPage
end


function AudioList:getScrollPage()
	return self.m_scrollPage
end


function AudioList:setScrollPosition(
	scrollPos
	)
	self.m_scrollPos = scrollPos
--	self:scrollRefresh()
end

function AudioList:getScrollPosition()
	return self.m_scrollPos
end


function AudioList:scrollRefresh()
	
	local	refresh = false
	
	if self.m_selectedPos ~= nil then
		if self.m_selectedPos >= self.m_scrollPos and self.m_selectedPos < (self.m_scrollPos + self.m_scrollPage) then
			
		else
			if self.m_selectedPos < self.m_scrollPos then
				self.m_scrollPos = self.m_selectedPos
				
				refresh = true
			else
				-- self.m_selectedPos >= self.m_scrollPos + self.m_scrollPage
				self.m_scrollPos = self.m_selectedPos - self.m_scrollPage + 1
				
				refresh = true
			end
		end
	end
	
	if self.m_scrollPos ~= nil then
		if (self.m_scrollPos + self.m_scrollPage) > #self:getList() then
			self.m_scrollPos = #self:getList() - self.m_scrollPage + 1
		end
		if self.m_scrollPos < 1 then self.m_scrollPos = 1 end
	end
	
end


function AudioList:prevSelectedPosition()
	if self.m_selectedPos == nil then
		if #self:getList() >= 1 then
			self.m_selectedPos = 1
		end
	else
		self.m_selectedPos = self.m_selectedPos - 1
		if self.m_selectedPos < 1 then
			self.m_selectedPos = 1
		end
	end
	
	self:scrollRefresh()
end

function AudioList:nextSelectedPosition()
	if self.m_selectedPos == nil then
		if #self:getList() >= 1 then
			self.m_selectedPos = 1
		end
	else
		self.m_selectedPos = self.m_selectedPos + 1
		if self.m_selectedPos > #self:getList() then
			self.m_selectedPos = #self:getList()
		end
	end
	
	self:scrollRefresh()
end


function AudioList:setCurrentPosition(
	currentPos
	)
		self.m_currentPos = currentPos
end


function AudioList:getCurrentPosition()
	return self.m_currentPos
end


function AudioList:getCurrentAudioManager(
	ready
	)
	
	if ready and self.m_currentPos == nil then
		if #self.m_list >= 1 then
			self.m_currentPos = 1
		end
	end
	
	return self.m_list[self.m_currentPos]
end


function AudioList:getPosAudioManager(
	pos
	)
	return self.m_list[pos]
end


function AudioList:getList()
	return self.m_list
end


function AudioList:getListCount()
	return #self.m_list
end


function AudioList:playToPosition(
	-- wʒûĐ
	pos
	)
	
	if self.m_currentPos ~= pos then
		if self:getCurrentAudioManager() then
			-- IɎ~߂
			if self:getCurrentAudioManager():getSource():isStopped() ~= true then
				self:getCurrentAudioManager():getSource():stop()
			end
		end
		self.m_currentPos = pos
	end
	
	if self:getCurrentAudioManager() then
		-- ̂
		self:play()
	end
end


function AudioList:play()
	local	audioManager = self:getCurrentAudioManager(true)
	if audioManager then
		audioManager:play()
		self.m_playing = true
	end
end


function AudioList:pause()
	local	audioManager = self:getCurrentAudioManager()
	if audioManager then
		audioManager:pause()
	end
end


function AudioList:stop()
	local	audioManager = self:getCurrentAudioManager()
	if audioManager then
		audioManager:stop()
		self.m_playing = false
	end
end


function AudioList:isPrevPosition()
	-- O邩
	return self.m_currentPos and self.m_list[self.m_currentPos - 1]
end


function AudioList:prev()
	-- O
	
	if self:isPrevPosition() then
		if self:getCurrentAudioManager() then
			-- IɎ~߂
			if self:getCurrentAudioManager():getSource():isStopped() ~= true then
				self:getCurrentAudioManager():getSource():stop()
			end
		end
		
		self.m_currentPos = self.m_currentPos - 1
		if self:getCurrentAudioManager() then
			-- ̂
			
			-- IړH
			self:setSelectedPosition(self.m_currentPos, true)
			
			self:getCurrentAudioManager():play()
		else
			self.m_currentPos = nil
			self.m_playing = false
		end
	end
end

function AudioList:isNextPosition()
	-- 邩
	return self.m_currentPos and self.m_list[self.m_currentPos + 1]
end

function AudioList:next()
	-- 
	
	if self:isNextPosition() then
		if self:getCurrentAudioManager() then
			-- IɎ~߂
			if self:getCurrentAudioManager():getSource():isStopped() ~= true then
				self:getCurrentAudioManager():getSource():stop()
			end
		end
		
		self.m_currentPos = self.m_currentPos + 1
		if self:getCurrentAudioManager() then
			-- ̂
			
			-- IړH
			self:setSelectedPosition(self.m_currentPos, true)
			
			self:getCurrentAudioManager():play()
		else
			self.m_currentPos = nil
			self.m_playing = false
		end
	end
end

function AudioList:setSeekPosbar(
	seekPosbar
	)
	self.m_seekPosbar = seekPosbar
end


function AudioList:isSeekPosbar()
	return self.m_seekPosbar
end


function AudioList:setSeekPosbarPercent(
	seekPosbarPercent
	)
	self.m_seekPosbarPercent = seekPosbarPercent
end


function AudioList:getSeekPosbarPercent()
	return self.m_seekPosbarPercent
end


function AudioList:setSeekVolume(
	seekVolume
	)
	self.m_seekVolume = seekVolume
end


function AudioList:isSeekVolume()
	return self.m_seekVolume
end


function AudioList:isNumberDisplay()
	local	audioManager = self:getCurrentAudioManager()
	local	source = nil
	local	bl = false
	if audioManager then
		source = audioManager:getSource()
	end
	if source then
		if source:isPlaying() == true then
			bl = true
		elseif source:isPaused() == true then
			if math.floor(self.m_stopTime % 2) == 0 then
				bl = true
			end
		end
	end
	return bl
end


function AudioList:getPosper()
	return self.m_posper
end


function AudioList:getPlayTime()
	return self.m_playTime
end


function AudioList:getTimeReverse()
	return self.m_timeReverse
end


function AudioList:setTimeReverse(
	timeReverse
	)
	self.m_timeReverse = timeReverse
end


function AudioList:update(dt, ...)
	local	audioManager = self:getCurrentAudioManager()
	if audioManager then
		audioManager:update(dt, ...)
		
		-- [vԂĎ
		if self.m_looping ~= audioManager:getSource():isLooping() then
			audioManager:getSource():setLooping(self.m_looping)
		end
		
		-- ĐIĂ玟ֈڍs
		if self.m_playing == true and audioManager:getSource():isStopped() == true then
			self:next()
		end
	else
		self.m_playing = false
	end
	
	-- posperZoibj
	self.m_posper = nil
	if self.m_seekPosbar == true then
		self.m_posper = self.m_seekPosbarPercent
	else
		local	audioManager = self:getCurrentAudioManager()
		local	source = nil
		if audioManager then source = audioManager:getSource() end
		if source == nil or source:isStopped() == true then
			self.m_posper = nil
		else
			local	soundStatus = audioManager:getSoundStatus()
			local	sample = audioManager:getSample()
			-- p[ZgZo
			self.m_posper = sample / soundStatus.sampleCount
		end
	end
	
	-- vCԂZoibj
	self.m_playTime = nil
	do
		local	audioManager = self:getCurrentAudioManager()
		local	source = nil
		local	sourceStatus = nil
		if audioManager then
			source = audioManager:getSource()
			soundStatus = audioManager:getSoundStatus()
		end
		if source and source:isStopped() == false and soundStatus then
			if self.m_timeReverse then
				self.m_playTime = soundStatus.duration - audioManager:getSecond()
			else
				self.m_playTime = audioManager:getSecond()
			end
		end
		
		-- XgbvĂۂɃ`J`JoJEg
		if source and source:isPaused() == true then
			self.m_stopTime = self.m_stopTime + dt
		else
			self.m_stopTime = 0
		end
	end
	
end


return AudioList
