
local	Block = {}

Block = class("Entities.Block", ccui.Layout)


function Block:ctor(...)
	cc.Node.ctor(self, ...)
	
	self:setBackGroundColor(cc.c4b(0xff, 0x00, 0x00, 0x80))
	self:setBackGroundColorType(2)
end


function Block:bumpBoundingBox()
	local	lt = cc.pSub(self:getPosition(), self:getAnchorPointInPoints())
	return lt.x, lt.y, self:getContentSize().width, self:getContentSize().height
end


function Block:getWorld()
	return self:getParent():getParent():getWorld()
end


function Block:onEnter()
	local	world = self:getWorld()
	if world then
		world:add(self, self:bumpBoundingBox())
	end
end

function Block:onExit()
	local	world = self:getWorld()
	if world then world:remove(self) end
end



return Block
