

local	GravityEntity = {}
GravityEntity = class("GravityEntity", ccui.Layout)

function GravityEntity:ctor(...)
	ccui.Layout.ctor(self, ...)
	
	self.m_vx = 0
	self.m_vy = 0
	
	self.m_gravity = 0
	
	self:scheduleUpdate()
end


function GravityEntity:bumpBoundingBox()
	local	lt = cc.pSub(self:getPosition(), self:getAnchorPointInPoints())
	return lt.x, lt.y, self:getContentSize().width, self:getContentSize().height
end


function GravityEntity:getWorld()
	return self:getParent():getParent():getWorld()
end


function GravityEntity:onEnter()
	local	world = self:getWorld()
	if world then world:add(self, self:bumpBoundingBox()) end
end

function GravityEntity:onExit()
	local	world = self:getWorld()
	if world then world:remove(self) end
end


function GravityEntity:updateInitialize(dt)
	self.m_vx, self.m_vy = 0, 0
end


function GravityEntity:update(dt, vx, vy)
	
	dt = math.min(dt, 0.1)
	vx = vx or 0
	vy = vy or 0
	
	self.m_gravity = self.m_gravity + dt * 3.0
	
	vy = vy + self.m_gravity
	
	local	world = self:getWorld()
	if world then
		local	goal_x = self:getPosition().x + vx
		local	goal_y = self:getPosition().y + vy
		
		-- ʂ󂯎ēWJ
		local	result_x, result_y, result_cols, result_len = world:move(
			self,
			goal_x,
			goal_y,
			self.moveFilter or nil
		)
		
		if result_len > 0 then
			if goal_y > result_y then
				-- n
				self.m_gravity = 0
--				self.m_gravity = -3
			elseif vy < 0 and result_y == self:getPosition().y then
				self.m_gravity = 0
			end
		end
		
		self:setPosition(cc.p(result_x, result_y))
	end
end

return GravityEntity

