
local	GravityEntity = import(".GravityEntity")

local	Player = {}

Player = class("Player", GravityEntity)

function Player:ctor(...)
	GravityEntity.ctor(self, ...)
	
	self:setBackGroundColor(cc.c3b(0x00, 0x00, 0xff))
	self:setBackGroundColorType(2)
	
	self.m_keys = {}
	
	self.m_horizontalAccel = 0
	
	-- vC[̓TCYŒ
	self:setContentSize(cc.size(32, 64))
	
	do
		local	eventKeyboard = cc.EventKeyboard:create()
		
		eventKeyboard.keyPressed = self.keyPressed
		eventKeyboard.keyReleased = self.keyReleased
		
		self:addEventListener(
			eventKeyboard
		)
	end
	
end


function Player:keyPressed(
	event
	)
	
	local	key, isrepeat = event:getKey()
	if key == "left" then
		self.m_keys[key] = true
		print("left on")
	elseif key == "right" then
		self.m_keys[key] = true
		print("right on")
	end
end


function Player:keyReleased(
	event
	)
	local	key, isrepeat = event:getKey()
	if key == "left" then
		self.m_keys[key] = false
		
		print("left off")
	elseif key == "right" then
		self.m_keys[key] = false
		print("right off")
	end
end


function Player:filter(other)
	return "slide"
end


function Player:update(dt)
	
	local	vx, vy = 0, 0
	
	if self.m_keys["left"] then
		self.m_horizontalAccel = self.m_horizontalAccel + dt * -20
	end
	if self.m_keys["right"] then
		self.m_horizontalAccel = self.m_horizontalAccel + dt *  20
	end
	
	if self.m_horizontalAccel > 0 then
		self.m_horizontalAccel = self.m_horizontalAccel - dt * 10
		if self.m_horizontalAccel < 0 then self.m_horizontalAccel = 0 end
	else
		self.m_horizontalAccel = self.m_horizontalAccel + dt * 10
		if self.m_horizontalAccel > 0 then self.m_horizontalAccel = 0 end
	end
	vx = self.m_horizontalAccel
	
--	if self.m_keys["left"] then
--		vx = vx + dt * -1000
--	elseif self.m_keys["right"] then
--		vx = vx + dt *  1000
--	end
	
	GravityEntity.update(self, dt, vx, vy)
	
	local	apip = self:getAnchorPointInPoints()
	
	self:getParent():getParent():lookAt(
		self:getPosition().x + apip.x,
		self:getPosition().y + apip.y
	)
end


return Player

