
local	Bump = import(".lib.bump")
local	Block = import(".Entities.Block")
local	Player = import(".Entities.Player")

local	Stage = {}
Stage = class("Stage", ccui.ScrollView)

local	width = 4000
local	height = 2000


function Stage:ctor(...)
	ccui.ScrollView.ctor(self, ...)
	
	-- [h
	self.m_world = Bump.newWorld()
	
	self:setBackGroundColor(cc.c3b(0xff, 0xff, 0xff))
	self:setBackGroundColorType(2)
	
	self:setInnerContainerSize(cc.size(width, height))
	
	-- walls & ceiling
	do
		local	rects = {
			cc.rect         (0,  0, width,          32),
			cc.rect(         0, 32,    32, height - 64),
			cc.rect(width - 32, 32,    32, height - 64)
		}
		for i = 1, #rects do
			local	block = Block:create()
			block:setPosition(cc.p(cc.rectGetMinX(rects[i]), cc.rectGetMinY(rects[i])))
			block:setContentSize(cc.size(rects[i].width, rects[i].height))
			self:addChild(block)
		end
	end
	
	-- tiled floor
	local	tilesOnFloor = 40
	for i = 0, tilesOnFloor - 1 do
		local	block = Block:create()
		block:setPosition(cc.p(i * width / tilesOnFloor, height - 32))
		block:setContentSize(cc.size(width / tilesOnFloor, 32))
		self:addChild(block)
	end
	
	-- random blocks
	for i = 1, 100 do
		local	block = Block:create()
		block:setPosition(cc.p(math.random(100, width - 200), math.random(100, height - 150)))
		block:setContentSize(cc.size(math.random(32, 100), math.random(32, 100)))
		self:addChild(block)
	end
	
	do
		local	player = Player:create()
		player:setPosition(cc.p(50, 50))
		self:addChild(player)
	end
	
	self:scheduleUpdate()
end

function Stage:update(dt)
--	print(self:getWorld():countItems())
end

function Stage:getWorld()
	return self.m_world
end

return Stage
