
--local	bump = import("..lib.bump")
--local	bump_debug = import("..lib.bump_debug")

local	Entity = import(".Entity")

local	GravityEntity = {}
GravityEntity = class("GravityEntity", Entity)

function GravityEntity:ctor(...)
	Entity.ctor(self, ...)
	
	self.m_gravityAccel = 500
	self.m_vx = 0
	self.m_vy = 0
end

function GravityEntity:onEnter()
	local	bump = self:getBump()
	if bump then
		bump.add(self)
	end
end

function GravityEntity:onExit()
	local	bump = self:getBump()
	if bump then
		bump.remove(self)
	end
end

function GravityEntity:pad(x, min, max)
  return x < min and min or (x > max and max or x)
end

function GravityEntity:padVelocity(maxdt, vx, vy)
  local	bump = self:getBump()
	if bump then
		local max = bump.getCellSize()/maxdt*0.5
		local min = -max
		return self:pad(vx, min, max), self:pad(vy, min, max)
	end
end

function GravityEntity:zero(x, limit)
  return math.abs(x) < limit and 0 or x
end

function GravityEntity:bumpUpdate(dt, maxdt)
	self.m_vy = self.m_vy + self.m_gravityAccel * dt
	self.m_vx, self.m_vy = self:padVelocity(maxdt, self.m_vx, self.m_vy)
	
	self:setPosition(cc.pAdd(self:getPosition(), cc.p(self.m_vx * dt, self.m_vy * dt)))
end

return GravityEntity

