
local	GravityEntity = import(".GravityEntity")

local	Player = {}

Player = class("Player", GravityEntity)

function Player:ctor(...)
	GravityEntity.ctor(self, ...)
	
	self:setBackGroundColor(cc.c3b(0x00, 0x00, 0xff))
	self:setBackGroundColorType(1)
	
	-- vC[̓TCYŒ
	self:setContentSize(cc.size(32, 64))
end


function Player:bumpShouldCollide(obj)
	return true
end


function Player:sign(x)
  return x < 0 and -1 or (x > 0 and 1 or 0)
end


function Player:bumpCollision(obj, dx, dy)
	if dx~=0 or dy~=0 then -- it can only be a block then
		if dx ~= 0 and self:sign(self.m_vx) ~= self:sign(dx) then self.m_vx = 0 end
		if dy ~= 0 and self:sign(self.m_vy) ~= self:sign(dy) then self.m_vy = 0 end
		self:setPosition(cc.p(self:getPosition().x + dx, self:getPosition().y + dy))
	end
end


function Player:bumpUpdate(dt, maxdt)
	GravityEntity.bumpUpdate(self, dt, maxdt)
	self:getParent():getParent():lookAt(self:getPosition().x, self:getPosition().y)
end


return Player

