-- ^fBN^[EEEƋɂƂ銴

local	Node = import(".Node")
local	SourceManager = import(".SourceManager")
local	ActionManager = import(".ActionManager")

local	Director = {}
Director = class("cc.Director", Node)

Director.m_instance = nil

function Director:ctor(...)
	Node.ctor(self, ...)
	
	self.m_director = self
	self.m_runScene = nil
	self.m_debugDraw = false
	
	self.m_stencilList = {}
	
	-- \[X}l[W[
	self.m_sourceManger = SourceManager:create()
	-- ANV}l[W[
	self.m_actionManger = ActionManager:create()
	
	-- CX^X𐶐
	Director.m_instance = self
end


function Director:getInstance(...)
	return self.m_director or Director.m_instance
end


function Director:loadSource(type, ...)
	return self.m_sourceManger:loadSource(type, ...)
end


function Director:getDebugDraw()
	return self.m_debugDraw
end


function Director:setDebugDraw(
	debugDraw
	)
	self.m_debugDraw = debugDraw
end


function Director:runWithScene(
	scene
	)
	self:addChild(scene)
	self.m_runScene = scene
end


function Director:getRunScene()
	return self.m_runScene
end


function Director:update(
	dt
	)
	if self.m_runScene then
		self.m_runScene:onUpdate(dt)
	end
end


function Director:draw()
	self.m_stencilList = {}
	self.m_nodeManager:onDraw()
end


function Director:pushStencil(
	func,
	area
	)
	table.insert(self.m_stencilList, {func, area } )
	love.graphics.stencil(func, "replace", 1)
	love.graphics.setStencilTest("greater", 0)
end


function Director:popStencil()
	local	list
	table.remove(self.m_stencilList)
	list = self.m_stencilList[#self.m_stencilList]
	if list then
		love.graphics.stencil(list[1], "replace", 1)
		love.graphics.setStencilTest("greater", 0)
	else
		love.graphics.setStencilTest()
	end
end


function Director:mousemoved(...)
	if self.m_runScene then
		self.m_runScene:mousemoved(...)
	end
end


function Director:mousepressed(...)
	if self.m_runScene then
		self.m_runScene:mousepressed(...)
	end
end


function Director:mousereleased(...)
	if self.m_runScene then
		self.m_runScene:mousereleased(...)
	end
end


function Director:wheelmoved(...)
	if self.m_runScene then
		self.m_runScene:wheelmoved(...)
	end
end


function Director:keypressed(...)
	if self.m_runScene then
		self.m_runScene:keypressed(...)
	end
end


function Director:keyreleased(...)
	if self.m_runScene then
		self.m_runScene:keyreleased(...)
	end
end


return Director
