
local	EventKeyboardManager = {}

EventKeyboardManager = class("cc.EventKeyboardManager")

function EventKeyboardManager:ctor()
	
	
	-- s[g⑫
	love.keyboard.setKeyRepeat(true)
	
	self.m_key = nil
	self.m_isrepeat = nil
	self.m_keys = {}
	
	self.m_capture = nil
	self.m_list = {}
end


function EventKeyboardManager:addNode(
	node,
	event
	)
	
	event.m_manager = self
	self.m_list[node] = event
end


function EventKeyboardManager:removeNode(
	node
	)
	self.m_list[node] = nil
end


function EventKeyboardManager:getCapture(
	-- 
	)
	return self.m_capture
end


function EventKeyboardManager:setCapture(
	-- 
	capture
	)
	self.m_capture = capture
end


function EventKeyboardManager:removeCapture(
	-- 
	)
	self.m_capture = nil
end


function EventKeyboardManager:getKey()
	return self.m_key, self.m_isrepeat
end

function EventKeyboardManager:getKeys()
	return self.m_keys
end

function EventKeyboardManager:callEvent(
	callname
	)
	
	local	capture = self.m_capture
	if capture then
		local	event = self.m_list[capture]
		if type(event[callname]) == "function" then
			event[callname](capture, event)
		end
	else
		local	tbls = {}
		table.walk(
			self.m_list,
			function(event, node)
				table.insert(tbls, { node = node, event = event })
			end
		)
		table.sort(
			tbls,
			function(a, b)
				return a.node:getDrawOrder() > b.node:getDrawOrder()
			end
		)
		for index, tbl in ipairs(tbls) do
			if type(tbl.event[callname]) == "function" and tbl.node:isVisible() then
--			if type(tbl.event[callname]) == "function" and tbl.node.m_visible then
				local	bl = tbl.event[callname](tbl.node, tbl.event)
				if bl then break end
			end
		end
	end
end


function EventKeyboardManager:keypressed(
	key,
	scancode,
	isrepeat
	)
	
	self.m_key = key
	self.m_isrepeat = isrepeat
	self.m_keys[key] = true
	
--	print("released", key, scancode, isrepeat)

	-- Ƃ肠Ă݂
	self:callEvent("keyPressed")
end


function EventKeyboardManager:keyreleased(
	key
	)
	
	self.m_key = key
	self.m_isrepeat = false
	self.m_keys[key] = false
	
--	print("released", key)
	-- Ƃ肠Ă݂
	self:callEvent("keyReleased")
end


return EventKeyboardManager
