local	Layer = import(".Layer")

local	LayerColor = {}

LayerColor = class("cc.LayerColor", Layer)


function LayerColor:ctor(
	color,
	width,
	height,
	...
	)
	Layer.ctor(self, color, width, height, ...)
	
	self.m_backGroundColorType = 2
	self.m_backGroundColor = color or cc.c3b(0xff, 0xff, 0xff)
	
	if width and height then
		self:setContentSize(cc.size(width, height))
	end
end


function LayerColor:draw(...)
	
	do
		local	backupColor = { love.graphics.getColor() }
		
		love.graphics.setColor(self.m_backGroundColor.r, self.m_backGroundColor.g, self.m_backGroundColor.b, self.m_backGroundColor.a)
		
		local	mode = {
			"line",
			"fill"
		}
		local	x, y = self:getDrawSpace().x, self:getDrawSpace().y
		local	width, height = self:getContentSize().width, self:getContentSize().height
		
		love.graphics.polygon(
			mode[self.m_backGroundColorType],
			x, y,
			x + width, y,
			x + width, y + height,
			x, y + height
		)
		love.graphics.setColor(unpack(backupColor))
	end
	
	Layer.draw(self, ...)
end

return LayerColor

