-- Ȃ񂿂ăm[h}l[W[

local	NodeManager = {}
NodeManager = class("cc.NodeManager")


function NodeManager:ctor(node)
	self.m_node = node
	self.m_list = {}
	self.m_add = {}
	self.m_remove = {}
	self.m_active = false
	self.m_rowid = 0
end


--function NodeManager:getNode(
--	return self.m_node
--end


function NodeManager:addChild(
	child
	)
	self.m_rowid = self.m_rowid + 1
	child.m_rowid = self.m_rowid
	table.insert(self.m_add, child)
end


function NodeManager:removeChild(
	child
	)
	table.insert(self.m_remove, child)
end



function NodeManager:cleanup()
	-- 폜
	do
		for index, child in ipairs(self.m_remove) do
			if type(child.onExit) == "function" then
				child:onExit()
			end
			-- qvf폜
			child:removeAllChildren()
			child:getNodeManager():cleanup()
			-- 폜JEgij
			cc.onExitCount = cc.onExitCount or 0
			cc.onExitCount = cc.onExitCount + 1
			
			-- 폜Ăij
			if child:getScene() then
				child:getScene():removeSchedule(child)
				child:getScene():removeEventMouseListener(child)
				child:getScene():removeEventKeyboardListener(child)
			end
			
			table.removebyvalue(self.m_list, child)
		end
		self.m_remove = {}
	end
	-- ǉ
	do
		for index, child in ipairs(self.m_add) do
			
			-- Ă݂
			child:getNodeManager():cleanup()
			
			if type(child.onEnter) == "function" then
				child:onEnter()
			end
			-- o^JEgij
			cc.onEnterCount = cc.onEnterCount or 0
			cc.onEnterCount = cc.onEnterCount + 1
			
			child:registerEntries()
			
			table.insert(self.m_list, child)
		end
		self.m_add = {}
	end
	
	-- ёւij
	table.sort(
		self.m_list,
		function(a, b)
			if a.m_localZOrder ~=  b.m_localZOrder then
				return a.m_localZOrder < b.m_localZOrder
			end
			return a.m_rowid < b.m_rowid
		end
	)
end


function NodeManager:getChildByTag(
	-- ^OtQbg
	tag
	)
	for i, child in ipairs(self.m_list) do
		if child.m_tag and child.m_tag == tag then
			return child
		end
	end
end


function NodeManager:getChildByName(
	-- OtQbg
	name
	)
	for i, child in ipairs(self.m_list) do
		if child.m_name and child.m_name == name then
			return child
		end
	end
end

function NodeManager:onDraw(
	-- `
	drawOrder
	)
	drawOrder = drawOrder or 1
	
	-- N[Abv
	self:cleanup()
	
	local	c, i, max = 0, 1, #self.m_list
	while i <= max do
		local	child = self.m_list[i]
		-- 폜ꂽǂ`FbN
		if table.indexof(self.m_remove, child) == false then
			
			child:registerEntries()
			
			if child:isVisible() == true then
				if child.m_nodeManager then
					child.m_drawOrder = drawOrder
					drawOrder = drawOrder + 1
					
					local	lt = cc.pSub(child:getPosition(), child:getAnchorPointInPoints())
					
					child.m_drawSpace = cc.pAdd(self.m_node.m_drawSpace, lt)
					child.m_clippingFlag = false
					
					if child.m_clippingType == 1 then
						local	stencilDrawArea = child:getStencilDrawArea()
						
						if stencilDrawArea.width > 0 and stencilDrawArea.height > 0 then
							local	stencilFunc = function()
								love.graphics.polygon(
									"fill",
									stencilDrawArea.x, stencilDrawArea.y,
									stencilDrawArea.x + stencilDrawArea.width, stencilDrawArea.y,
									stencilDrawArea.x + stencilDrawArea.width, stencilDrawArea.y + stencilDrawArea.height,
									stencilDrawArea.x, stencilDrawArea.y + stencilDrawArea.height
								)
							end
							self.m_node:getDirector():pushStencil(stencilFunc, stencilDrawArea)
							child.m_clippingFlag = true
						end
					end
					if type(child.draw) == "function" then
						child.draw(child)
					end
					drawOrder = child.m_nodeManager.onDraw(child.m_nodeManager, drawOrder)
					
					if child.m_clippingFlag == true then
						self.m_node:getDirector():popStencil()
					end
				end
				c = c + 1
			end
		else
			table.removebyvalue(self.m_list, child)
			table.remove(self.m_list, i)
			i = i - 1
			max = max - 1
		end
		i = i + 1
	end
	
	return drawOrder
end

return NodeManager
