--
-- cc.Node -> ccui.Layout
--

local	Sprite = import("..cc.Sprite")
local	Node = import("..cc.Node")
local	Layout = {}
Layout = class("ccui.Layout", Node)


function Layout:ctor(...)
	Node.ctor(self, ...)
	self.m_backGroundColorType = ccui.LayoutBackGroundColorType.none
	self.m_backGroundColor = cc.c3b(255, 255, 255)
	
	-- とりあえずはゼロ
	self.m_clippingType = 0
end


function Layout:getClippingType()
	return self.m_clippingType
end


function Layout:setClippingType(
	clippingType
	)
	self.m_clippingType = clippingType
end


function Layout:setBackGroundColorType(
	backGroundColorType
	)
	self.m_backGroundColorType = backGroundColorType
end


function Layout:setBackGroundColor(
	backGroundColor
	)
	self.m_backGroundColor = backGroundColor
end


function Layout:setBackGroundImage(
	fileName
	)
	
	local	image = self:getChildByName("image")
	
	if image == nil then
		image = Sprite:create()
		image:setName("image")
		self:addChild(image)
	end
	if image then
		image:initWithFile(fileName)
		image:setPosition(self:getContentSize().width * 0.5, self:getContentSize().height * 0.5)
	end
end


function Layout:draw(...)
	if self.m_backGroundColorType ~= ccui.LayoutBackGroundColorType.none then
		
		local	backupColor = { love.graphics.getColor() }
		
		love.graphics.setColor(self.m_backGroundColor.r, self.m_backGroundColor.g, self.m_backGroundColor.b, self.m_backGroundColor.a)
		
		local	mode = {
			"line",
			"fill"
		}
		local	x, y = self:getDrawSpace().x, self:getDrawSpace().y
		local	width, height = self:getContentSize().width, self:getContentSize().height
		
		love.graphics.polygon(
			mode[self.m_backGroundColorType],
			x, y,
			x + width, y,
			x + width, y + height,
			x, y + height
		)
		love.graphics.setColor(unpack(backupColor))
	end
	
	Node.draw(self)
end


return Layout