-- ナンチャッテテキストアトラス

local	Node = import("..cc.Node")

local	g_texture = texture

local	TextAtlas = {}
TextAtlas = class("ccui.TextAtlas", Node)


function TextAtlas:ctor(...)
	
	Node.ctor(self, ...)
	
	self:setAnchorPoint(cc.p(0.5, 0.5))
	self.m_stringValue = ""
	self.m_stringMapFile = ""
	self.m_itemWidth = 0
	self.m_itemHeight = 0
	self.m_charMap = ""
	self.m_gap = 0
	
	self.m_texture = nil
	self.m_textures = {}
end


function TextAtlas:setProperty(
	stringValue,
	charMapFile,
	itemWidth,
	itemHeight,
	charMap		-- ちょっと変えた（キャラクターマップを完全指定してね）
	)
	
	self.m_charMapFile = charMapFile
	self.m_itemWidth = itemWidth
	self.m_itemHeight = itemHeight
	self.m_charMap = charMap
	
	self.m_texture = self:getDirector():loadSource("image", self.m_charMapFile)
--	self.m_texture = love.graphics.newImage(self.m_charMapFile)
	self.m_charTextureRects = {}
	
	if self.m_texture then
		local	mapWidth, mapHeight = self.m_texture:getWidth(), self.m_texture:getHeight()
--		local	mapWidth, mapHeight = self.m_texture:getsize()
		local	xPos, yPos = 0, 0
		
		-- めんどいので、日本語非対応・・；
		local	len = string.len(self.m_charMap)
		for i = 1, len do
			local	char = string.sub(self.m_charMap, i, i)
			self.m_charTextureRects[char] = love.graphics.newQuad(xPos, yPos, self.m_itemWidth, self.m_itemHeight, mapWidth, mapHeight)
--			self.m_charTextureRects[char] = cc.rect(xPos, yPos, self.m_itemWidth, self.m_itemHeight)
			
			xPos = xPos + itemWidth
			if xPos > mapWidth then
				xPos = 0
				yPos = yPos + itemHeight
				if yPos > mapHeight then
					break
				end
			end
		end
	end
	
	self:setStringValue(stringValue)
end


function TextAtlas:setStringValue(
	stringValue
	)
	self.m_stringValue = stringValue
	local	len = string.len(self.m_stringValue)
	self:setContentSize(cc.size(self.m_itemWidth * len + self.m_gap * (len - 1), self.m_itemHeight))
end


function TextAtlas:draw()
	
	if self.m_texture then
--		local	lt = cc.pSub(self:getPosition(), self:getAnchorPointInPoints())
		
		local	drawSpace = self:getDrawSpace()
		local	xPos, yPos = drawSpace.x, drawSpace.y
		
		-- めんどいので、日本語非対応・・；
		local	len = string.len(self.m_stringValue)
		for i = 1, len do
			local	char = string.sub(self.m_stringValue, i, i)
			local	textureRect = self.m_charTextureRects[char]
			
			if textureRect then
				love.graphics.draw(
					self.m_texture,
					textureRect,
					math.floor(xPos),
					math.floor(yPos)
				)
--				self.m_texture:drawrect(
--					xPos,
--					yPos,
--					self.m_itemWidth,
--					self.m_itemHeight,
--					textureRect.x,
--					textureRect.y,
--					255
--				)
			end
			
			xPos = xPos + self.m_itemWidth + self.m_gap
		end
	end
	
	Node.draw(self)
end

return TextAtlas